// $Author: limin $

// $DateTime: 2011/02/28 15:49:31 $

// $File: //mobile/col_mobile/new/prod/launcher/mobilelaunch.template.js $

// $Revision: #5 $



// Licensed Materials - Property of IBM

// BI and PM: Mobile

// (C) Copyright IBM Corp. 2011

// US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.



var mobilelaunch = new mobilelaunchHelper();

mobilelaunch.init();



function mobilelaunchHelper(){

	var fnRedirect = null;

	var mobilelaunchPage = new launchPage();

	var mobileType = "";

	var bbOSVersion = 0;



	this.init = function(){

		getMobileType();

		setRedirectFn();

		mobilelaunchPage.init(mobileType);

	}



	this.willRedirect = function(){

		if (fnRedirect != null)

			return true;

		return false;

	}

	

	this.doRedirect = function(){

		if (fnRedirect != null)

			fnRedirect();

	}

	

	this.launchPortal = function(portalType){

		mobilelaunchPage.launchPortal(portalType);

	}



	var getMobileType = function(){

		mobileType = "";

		if (navigator.userAgent){

			var agent = navigator.userAgent.toLowerCase();
					
			if (/blackberry.*(version)*\/(\d+\.\d+)\./.test(agent)) {

				mobileType = "BlackBerry";

				bbOSVersion = new Number(RegExp.$2);				

			}
			else if (agent.indexOf("webkit") != -1 && agent.indexOf("mobile") != -1)

				mobileType = "mob_webkit";

			

			else if (agent.indexOf("webkit") != -1 && ( agent.indexOf("playbook") != -1 || agent.indexOf("android") != -1) )



				mobileType = "mob_webkit";



			else if (agent.indexOf("symbian") != -1)

				mobileType = "Symbian";

			else if (agent.indexOf("windows ce") != -1)

				mobileType = "Windows Mobile";

		}
		

	}



	var setRedirectFn = function(){

		switch (mobileType){

		case "BlackBerry":

			if (bbOSVersion < 4.6){

				fnRedirect = mobilelaunchPage.redirectInstaller;

				break;

			}

		case "mob_webkit":

		case "Symbian":

		case "Windows Mobile":

			fnRedirect = getMobileRedirectFn();

			break;

		default:

			fnRedirect = null;

			break;

		}

	}



	var getMobileRedirectFn = function(){

		var mobileRedirectFn = null;

		var savedPortal = getCookie("mob_portal");

		if (savedPortal){

			if (savedPortal == "mobile")

				if (mobileType == "mob_webkit")

					mobileRedirectFn = mobilelaunchPage.redirectMobilePortal;

				else

					mobileRedirectFn = mobilelaunchPage.redirectInstaller;

		}

		else

			mobileRedirectFn = redirectLaunchPage;

		return mobileRedirectFn;

	}

	

	var redirectLaunchPage = function(){

		if (mobileType == "mob_webkit")

			mobilelaunchPage.genPage();

		else

			mobilelaunchPage.genPageOld();

	}

}



function launchPage(){

	var bIsapi = false;

	var cookiePath = '/';

	var i18n = new langHelper();

	var pathToRoot = "";

	var mobileType = "";

	

	this.init = function(mobType){

		mobileType = mobType;

		var pathBits = location.pathname.split('/');

		if (pathBits[pathBits.length-1] == "")

			pathBits.pop();

		if (pathBits[pathBits.length-1] == "isapi"){

			pathBits.pop();

			bIsapi = true;

			pathToRoot = "../"; 

		}

		else{ 

			bIsapi = false;

			pathToRoot = "";

		}

		cookiePath = pathBits.join('/');

		i18n.init(cookiePath);

	}

	

	this.updateOrientation = function(){

		if (window.orientation == 0)

			document.body.removeAttribute("landscape");

		else

			document.body.setAttribute("landscape", "true");

		window.scrollTo(0, 1);

	}



	this.launchPortal = function(portalType){

		if (document.getElementById("portalTypeSet").checked)

			setCookie("mob_portal", portalType, 365, cookiePath);

		

		if (portalType == "mobile"){

			if (mobileType == "mob_webkit")

				this.redirectMobilePortal();

			else

				this.redirectInstaller();

		}

		else  // Call Portals function to generate default entry page 

			genMainContent();

	}	

	

	this.genPage = function(){

		i18n.init(cookiePath);

		genMeta();

		genStyles();

		this.genLaunchBody();

	}



	this.redirectMobilePortal = function(){

		if (bIsapi)

			window.location.replace(pathToRoot + "m/isapi/index.htm");

		else

			window.location.replace(pathToRoot + "m/index.htm");

	}

	

	this.redirectInstaller = function(){

		window.location.replace(pathToRoot + "mobile/index.html");

	}

	

	this.genLaunchBody = function(){

		var _this = this;

		var elDiv = document.createElement('div');

		elDiv.className = 'dialog';



		var elTemp = document.createElement('p');

		elTemp.appendChild(document.createTextNode(i18n.get('LAUNCH_PORTAL_DESC')));

		elDiv.appendChild(elTemp);

		

		elTemp = document.createElement('p');

		elTemp.appendChild(document.createTextNode(i18n.get('LAUNCH_CHOOSE_OPTION')));

		elDiv.appendChild(elTemp);

		
		elTemp = document.createElement('a');

		elTemp.className = 'grey button';

		elTemp.onclick = function(){ _this.launchPortal('mobile') };

		elTemp.appendChild(document.createTextNode(i18n.get('LAUNCH_MOBILE_BTN')));

		elDiv.appendChild(elTemp);
		
		

		elTemp = document.createElement('a');

		elTemp.className = 'white button';

		elTemp.onclick = function(){ _this.launchPortal('desktop') };

		elTemp.appendChild(document.createTextNode(i18n.get('LAUNCH_DESKTOP_BTN')));

		elDiv.appendChild(elTemp);



		elDiv.appendChild(document.createElement('br'));

		

		elTemp = document.createElement('input');	

		elTemp.setAttribute('type', 'checkbox');

		elTemp.setAttribute('name', 'portalTypeSet');

		elTemp.id = 'portalTypeSet';

		elDiv.appendChild(elTemp);

		

		elTemp = document.createElement('label');

		elTemp.setAttribute('for', 'portalTypeSet');

		elTemp.style.paddingLeft = '6px';

		elTemp.appendChild(document.createTextNode(i18n.get('LAUNCH_REMEMBER_DECISION')));

		elDiv.appendChild(elTemp);

		

		var elBody = document.body;

		while (elBody.hasChildNodes()) elBody.removeChild(elBody.lastChild);

		elBody.appendChild(elDiv);

		elBody.onorientationchange = function(){ _this.updateOrientation() };

	}

	

	var createStyle = function(elParent, text){
	
		var style = document.createElement('style');
		
		style.type = 'text/css';
		
		if (isDefined(style.styleSheet)) // IE
			style.styleSheet.cssText = text;
		
		else 
		
			style.appendChild(document.createTextNode(text));
		
		elParent.appendChild(style);
		
	}
	
	var genIPadStyle = function (){
		
		var head = document.getElementsByTagName('head')[0]; 
		
		createStyle(head, 'body { color:#000000; font-family:Helvetica; font-size:18px; font-weight:bold; }');
			
		createStyle(head, 'p { margin:20px}');
		createStyle(head, 'input { margin:20px 10px 20px 20px}');
		
		createStyle(head, 'a.button { display:block;width:80%;border-width:0 9px; font-size:18px; font-weight:bold; line-height:45px;margin-top:10px;margin-bottom:10px; margin-left:auto;margin-right:auto; text-align:center; text-decoration:none; }');
		
		createStyle(head, 'a.white.button { color: #000; text-shadow: #FFF 0px 1px 1px !important; -webkit-border-image: url(' + pathToRoot + 'm/images/white_25.png) 0 11 0 11; }');
		
		createStyle(head, 'a.grey.button { color: #FFF; text-shadow: #333 0px 1px 1px !important; -webkit-border-image: url(' + pathToRoot + 'm/images/grey_25.png) 0 11 0 11; }');
		
		createStyle(head, '.dialog { width:100%;height:80%;background: url(' + pathToRoot + 'm/images/ibmtop_ipad.png) no-repeat;background-position: center;background-color:white; }');
	}

	var genIPhoneStyle = function (){
		
		var head = document.getElementsByTagName('head')[0]; 
		
		createStyle(head, 'body { color:#000000; font-family:Helvetica; font-size:16px; font-weight:bold; }');
			
		createStyle(head, 'a.button { border-width:0 9px; display:block; font-size:18px; font-weight:bold; line-height:35px; margin:2px; text-align:center; text-decoration:none; }');
		
		createStyle(head, 'a.white.button { color: #000; text-shadow: #FFF 0px 1px 1px !important; -webkit-border-image: url(' + pathToRoot + 'm/images/white_25.png) 0 11 0 11; }');
		
		createStyle(head, 'a.grey.button { color: #FFF; text-shadow: #333 0px 1px 1px !important; -webkit-border-image: url(' + pathToRoot + 'm/images/grey_25.png) 0 11 0 11; }');
		
		createStyle(head, '.dialog { background: url(' + pathToRoot + 'm/images/ibmtop.png) no-repeat; padding: 110px 5px 0pt 10px; }');
		
		createStyle(head, 'body[landscape] .dialog { background: url(' + pathToRoot + 'm/images/ibmtop.png) no-repeat; padding: 110px 5px 0pt 10px; }');
	}
	
	var genStyles = function(){

		

		if ((navigator.userAgent.match(/iPad/i))||(navigator.userAgent.match(/PlayBook/i) ) ) {
			
			genIPadStyle();
			
		}
		else {
			
			var widthDetected = 0;
			if (typeof(window.innerWidth) == 'number' && typeof(window.orientation) == 'number' ) {
		
					if ( window.orientation == 0 ) widthDetected = window.innerWidth;
				else widthDetected = window.innerHeight;
		
			} 
			if (widthDetected > 640) {
				genIPadStyle();
			}
			else {
				genIPhoneStyle();
			}
		}
	}



	var genMeta = function(){

		var head = document.getElementsByTagName('head')[0]; 

		var meta = document.createElement('meta');

		meta.name = "viewport";

		meta.content = "width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0";

		meta.setAttribute("id", "viewport");

		head.appendChild(meta); 

		

		meta = document.createElement('meta');

		meta.name = "apple-mobile-web-app-capable";

		meta.content = "yes";

		head.appendChild(meta); 

		

		meta = document.createElement('meta');

		meta.name = "apple-mobile-web-app-status-bar-style";

		meta.content = "black";

		head.appendChild(meta); 

	}

	

	this.genPageOld = function(){

		i18n.init(cookiePath);

		this.genLaunchBodyOld();

	}



	this.genLaunchBodyOld = function(){

		document.body.innerHTML = 

		'<style type="text/css">' +

		'body {	color:#000000; font-family:Helvetica; font-size:16px; font-weight:bold;	}' +		

		'.dialog { background: url(' + pathToRoot + 'm/images/ibmtop.png) no-repeat; padding: 110px 5px 0pt 10px; }' +		

		'body[landscape] .dialog { background: url(' + pathToRoot + 'm/images/ibmtop.png) no-repeat; padding: 110px 5px 0pt 10px; }' +

		'input.button { display:block; font-size:18px; text-align:center; text-decoration:none; }' +

		'</style>' +

		'<div style="background: url(' + pathToRoot + 'm/images/ibmtop.png) no-repeat; padding: 110px 5px 0pt 10px;">' +

		'<p>' + i18n.get('LAUNCH_PORTAL_DESC') + '</p>' +

		'<p>' + i18n.get('LAUNCH_CHOOSE_OPTION') + '</p>' +

		'<p><input type="button" class="grey button" onClick="mobilelaunch.launchPortal(\'mobile\')" value="' + mobileType + '"/></p>' +

		'<p><input type="button" class="white button" onClick="mobilelaunch.launchPortal(\'desktop\')" value="' + i18n.get('LAUNCH_DESKTOP_BTN') + '"/></p>' +
	

		'<br>' +

		'<input type="checkbox" name="portalTypeSet" id="portalTypeSet">' +

		'<label for="portalTypeSet" style="padding-left: 6px; ">' + i18n.get('LAUNCH_REMEMBER_DECISION') + '</label>' +

		'</div>';

	}

}



// Language support

function langHelper(){

	var language = "en";

	var aLangStrings = {"cs_LAUNCH_PORTAL_DESC": "Na mobilním zařízení máte možnost použít běžný desktopový portál (IBM Cognos Connection) nebo produkt IBM Cognos Mobile, jenž je optimalizován pro mobilní zařízení.",
"cs_LAUNCH_CHOOSE_OPTION": "Vyberte jednu z níže uvedených možností.",
"cs_LAUNCH_DESKTOP_BTN": "Použít desktopovou verzi (IBM Cognos Connection)",
"cs_LAUNCH_MOBILE_BTN": "Použít IBM Cognos Mobile",
"cs_LAUNCH_REMEMBER_DECISION": "Tuto volbu zapamatovat",
"de_LAUNCH_PORTAL_DESC": "Auf einem mobilen Gerät haben Sie die Möglichkeit, entweder das reguläre Desktop-Portal (IBM Cognos Connection) oder IBM Cognos Mobile zu verwenden, das für Ihre mobilen Geräte optimiert ist.",
"de_LAUNCH_CHOOSE_OPTION": "Wählen Sie unten eine dieser Möglichkeiten aus.",
"de_LAUNCH_DESKTOP_BTN": "Desktop-Version (IBM Cognos Connection) verwenden",
"de_LAUNCH_MOBILE_BTN": "IBM Cognos Mobile verwenden",
"de_LAUNCH_REMEMBER_DECISION": "Meine Auswahl speichern",
"es_LAUNCH_PORTAL_DESC": "En un dispositivo móvil, tiene la opción de utilizar el portal del equipo de sobremesa normal (IBM Cognos Connection) o de utilizar IBM Cognos Mobile, que se ha optimizado para su dispositivo móvil.",
"es_LAUNCH_CHOOSE_OPTION": "Seleccione una de las opciones siguientes.",
"es_LAUNCH_DESKTOP_BTN": "Utilizar la versión del equipo de sobremesa (IBM Cognos Connection)",
"es_LAUNCH_MOBILE_BTN": "Utilizar IBM Cognos Mobile",
"es_LAUNCH_REMEMBER_DECISION": "Recordar mi decisión",
"fi_LAUNCH_PORTAL_DESC": "Mobiililaitteessa voi käyttää tavallista työpöytäportaalia (IBM Cognos Connection) tai IBM Cognos Mobilea, joka on optimoitu mobiililaitteellesi.",
"fi_LAUNCH_CHOOSE_OPTION": "Valitse asetus alla.",
"fi_LAUNCH_DESKTOP_BTN": "Käytä työpöytäversiota (IBM Cognos Connection)",
"fi_LAUNCH_MOBILE_BTN": "Käytä IBM Cognos Mobilea",
"fi_LAUNCH_REMEMBER_DECISION": "Muista valinta",
"fr_LAUNCH_PORTAL_DESC": "Sur un périphérique mobile, vous avez l'option d'utiliser le portail normal du bureau (IBM Cognos Connection), ou IBM Cognos Mobile, qui est optimisé pour votre périphérique mobile.",
"fr_LAUNCH_CHOOSE_OPTION": "Veuillez choisir l'une des options ci-dessous.",
"fr_LAUNCH_DESKTOP_BTN": "Utiliser la version bureau (IBM Cognos Connection)",
"fr_LAUNCH_MOBILE_BTN": "Utiliser IBM Cognos Mobile",
"fr_LAUNCH_REMEMBER_DECISION": "Mémoriser ma décision",
"hu_LAUNCH_PORTAL_DESC": "Mobil eszközökön az asztali gépeken használt hagyományos portál (IBM Cognos Connection) vagy a mobil eszközökre optimalizált IBM Cognos Mobile alkalmazás is használható.",
"hu_LAUNCH_CHOOSE_OPTION": "Válasszon az alábbi beállítások közül.",
"hu_LAUNCH_DESKTOP_BTN": "Az asztali gépeken használt verzió (IBM Cognos Connection) használata",
"hu_LAUNCH_MOBILE_BTN": "Az IBM Cognos Mobile használata",
"hu_LAUNCH_REMEMBER_DECISION": "Beállítás megjegyzése",
"it_LAUNCH_PORTAL_DESC": "In un dispositivo mobile, vi è la possibilità di usare il portale desktop normale (IBM Cognos Connection) o di usare IBM Cognos Mobile ottimizzato per il dispositivo mobile.",
"it_LAUNCH_CHOOSE_OPTION": "Selezionare una delle opzioni indicate sotto.",
"it_LAUNCH_DESKTOP_BTN": "Usa la versione desktop (IBM Cognos Connection)",
"it_LAUNCH_MOBILE_BTN": "Usa IBM Cognos Mobile",
"it_LAUNCH_REMEMBER_DECISION": "Ricorda l'opzione selezionata",
"ja_LAUNCH_PORTAL_DESC": "携帯機器では、標準のデスクトップ ポータル (IBM Cognos Connection) を使用することも、使用している携帯機器に最適化された IBM Cognos Mobile を使用することもできます。",
"ja_LAUNCH_CHOOSE_OPTION": "次のオプションのいずれかを選択してください。",
"ja_LAUNCH_DESKTOP_BTN": "デスクトップ バージョン (IBM Cognos Connection) を使用",
"ja_LAUNCH_MOBILE_BTN": "IBM Cognos Mobile を使用",
"ja_LAUNCH_REMEMBER_DECISION": "この選択を保存",
"nl_LAUNCH_PORTAL_DESC": "Op uw mobiele apparaat kunt u de gewone bureaubladportal (IBM Cognos Connection) gebruiken, of IBM Cognos Mobile, een toepassing die is geoptimaliseerd voor uw mobiele apparaat.",
"nl_LAUNCH_CHOOSE_OPTION": "Kies een van de opties hieronder.",
"nl_LAUNCH_DESKTOP_BTN": "Bureaubladversie gebruiken (IBM Cognos Connection)",
"nl_LAUNCH_MOBILE_BTN": "IBM Cognos Mobile gebruiken",
"nl_LAUNCH_REMEMBER_DECISION": "Mijn keuze onthouden",
"pl_LAUNCH_PORTAL_DESC": "Na urządzeniu przenośnym masz opcję użycia zwykłego portalu pulpitu (IBM Cognos Connection) lub IBM Cognos Mobile, który jest zoptymalizowany dla urządzenia przenośnego.",
"pl_LAUNCH_CHOOSE_OPTION": "Wybierz jedną z poniższych opcji.",
"pl_LAUNCH_DESKTOP_BTN": "Użyj wersji pulpitu (IBM Cognos Connection)",
"pl_LAUNCH_MOBILE_BTN": "Użyj IBM Cognos Mobile",
"pl_LAUNCH_REMEMBER_DECISION": "Zapamiętaj moją decyzję",
"pt_LAUNCH_PORTAL_DESC": "Em dispositivos móveis, há a possibilidade de uso do portal do desktop regular (IBM Cognos Connection) ou do IBM Cognos Mobile, que é aperfeiçoado para o dispositivo móvel.",
"pt_LAUNCH_CHOOSE_OPTION": "Escolha uma das opções abaixo.",
"pt_LAUNCH_DESKTOP_BTN": "Utilize a versão de desktop (IBM Cognos Connection)",
"pt_LAUNCH_MOBILE_BTN": "Utilize o IBM Cognos Mobile",
"pt_LAUNCH_REMEMBER_DECISION": "Lembrar minha decisão",
"ro_LAUNCH_PORTAL_DESC": "Pe un dispozitiv mobil, aveţi opţiunea de a utiliza portalul desktop obişnuit (IBM Cognos Connection) sau IBM Cognos Mobile, care este optimizat pentru dispozitivul dvs. mobil.",
"ro_LAUNCH_CHOOSE_OPTION": "Alegeţi una dintre opţiunile de mai jos.",
"ro_LAUNCH_DESKTOP_BTN": "Utilizare versiune desktop (IBM Cognos Connection)",
"ro_LAUNCH_MOBILE_BTN": "Utilizare IBM Cognos Mobile",
"ro_LAUNCH_REMEMBER_DECISION": "Reţine decizia mea",
"ru_LAUNCH_PORTAL_DESC": "При работе с мобильным устройством можно использовать обычный портал для настольного компьютера (IBM Cognos Connection), либо IBM Cognos Mobile, оптимизированный специально для мобильного устройства.",
"ru_LAUNCH_CHOOSE_OPTION": "Выберите один из вариантов ниже.",
"ru_LAUNCH_DESKTOP_BTN": "Использовать версию для настольного компьютера (IBM Cognos Connection)",
"ru_LAUNCH_MOBILE_BTN": "Использовать IBM Cognos Mobile",
"ru_LAUNCH_REMEMBER_DECISION": "Запомнить выбор",
"sv_LAUNCH_PORTAL_DESC": "På en mobil enhet kan du använda den vanliga skrivbordsportalen (IBM Cognos Connection) eller IBM Cognos Mobile, som har optimerats för din mobila enhet.",
"sv_LAUNCH_CHOOSE_OPTION": "Välj ett av nedanstående alternativ.",
"sv_LAUNCH_DESKTOP_BTN": "Använd skrivbordsversionen (IBM Cognos Connection)",
"sv_LAUNCH_MOBILE_BTN": "Använd IBM Cognos Mobile",
"sv_LAUNCH_REMEMBER_DECISION": "Kom ihåg mitt val",
"tr_LAUNCH_PORTAL_DESC": "Taşınabilir bir aygıtta, normal masaüstü portalını veya taşınabilir aygıtınız için optimize edilmiş IBM Cognos Mobile'ı kullanma seçeneğiniz vardır.",
"tr_LAUNCH_CHOOSE_OPTION": "Lütfen aşağıdaki seçeneklerden birini seçin.",
"tr_LAUNCH_DESKTOP_BTN": "Masaüstü sürümünü kullan (IBM Cognos Connection)",
"tr_LAUNCH_MOBILE_BTN": "IBM Cognos Mobile'ı Kullan",
"tr_LAUNCH_REMEMBER_DECISION": "Seçimimi hatırla",
"zh-cn_LAUNCH_PORTAL_DESC": "在移动设备上，您可以选择使用常规的桌面门户 (IBM Cognos Connection) 或使用已针对您的移动设备进行了优化的 IBM Cognos Mobile。",
"zh-cn_LAUNCH_CHOOSE_OPTION": "请选择以下选项之一。",
"zh-cn_LAUNCH_DESKTOP_BTN": "使用桌面版本 (IBM Cognos Connection)",
"zh-cn_LAUNCH_MOBILE_BTN": "使用 IBM Cognos Mobile",
"zh-cn_LAUNCH_REMEMBER_DECISION": "记住我的选择",
"en_LAUNCH_PORTAL_DESC": "On a mobile device, you have the option of using the regular desktop portal (IBM Cognos Connection), or using IBM Cognos Mobile, which is optimized for your mobile device.",
"en_LAUNCH_CHOOSE_OPTION": "Please choose one of those options below.",
"en_LAUNCH_DESKTOP_BTN": "Use the desktop version (IBM Cognos Connection)",
"en_LAUNCH_MOBILE_BTN": "Use IBM Cognos Mobile",
"en_LAUNCH_REMEMBER_DECISION": "Remember my decision"};

	

	this.get = function(key){

		var result = aLangStrings[language + "_" + key];

		if( result == null ) return key;

		return result;

	}



	this.init = function(cookiePath){

		var langs = ["en", "cs", "de", "es", "fi", "fr", "hu", "it", "ja", "nl", "pl", "pt", "ro", "ru", "sv", "tr", "zh-cn"];

	

		// figure out default language settings

		var l = getCookie("mob_lang");

		if (l == null){

			// never loaded before

			if( navigator.language ) l = navigator.language.substring(0, 2);

			else l = "en";

			if (l == "zh") l = "zh-cn";

			

			var foundLang = false;

			for (var i = 0; i < langs.length; i++)

				if (langs[i] == l){

					foundLang = true;

					break;

				}

			if (!foundLang){

				var msg = "The language '" + navigator.language + "' you chose is not supported yet.  Please contact your administrator for help.";

				alert(msg);

				l = "en";

			}

			setCookie("mob_lang", l, 60, cookiePath);

		} else {

			// been here before, loading lang

			setCookie("mob_lang", l, 60, cookiePath);

		}

		language = l;

	}

}



// Cookie support

function getCookie(name){

	var arg = name + "=";

	var alen = arg.length;

	var clen = document.cookie.length;

	var i = 0;

	while (i < clen){

		var j = i + alen;

		if (document.cookie.substring(i, j) == arg)

			return getCookieVal(j);

		i = document.cookie.indexOf(" ", i) + 1;

		if (i == 0)

			break; 

	}

	return null;

}



function getCookieVal(offset){

	var endstr = document.cookie.indexOf(";", offset);

	if (endstr == -1)

		endstr = document.cookie.length;

	return document.cookie.substring(offset, endstr);

}



function setCookie(name, value, expires, path){

	var date = new Date();

	expires = new Date(date.getTime() + (expires * 1000 * 60 * 60 * 24));

	document.cookie = name + "=" + value +

		((expires) ? "; expires=" + expires.toGMTString() : "") +

		((path)    ? "; path=" + path : "");

}



// Misc

function isDefined(objName){

	return (typeof objName!="undefined" && typeof objName!="unknown");

}



