#!/bin/sh
################################################################
# Licensed Materials - Property of IBM
#
# IBM Cognos Products: Mobile
#
# (C) Copyright IBM Corp. 2011
#
# US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
################################################################

# ---------------------------------------------------------------------------
# Shell script (UNIX) to set the Mobile launch content during install/uninstall
# Installing the Mobile launch content will enable a seperate entry web page for mobile device users
# 
# Arguments -install to add the Mobile launch content 
#           -uninstall to remove the Mobile launch content
# ---------------------------------------------------------------------------

if [ "$1" = "-install" ]
then
	cp mobilelaunch.install.js ../../webcontent/ps/mobile/js/mobilelaunch.js
elif [ "$1" = "-uninstall" ]
then
	cp mobilelaunch.uninstall.js ../../webcontent/ps/mobile/js/mobilelaunch.js
else
	echo "Unknown command parameter was specified"
	echo "Usage: mobilelaunch.sh <command>"
	echo "Where command could be one of the following"
	echo "  -install"
	echo "       add launch entry web page for mobile users"
	echo "  -uninstall"
	echo "       remove launch entry web page for mobile users"
fi

exit $?
