<?xml version="1.0" encoding="UTF-8"?>
<!--
$Author: bibldscm $
$DateTime: 2010/08/23 11:07:18 $
$File: //mobile/col_mobile/new/prod/server/templates/mobile/process-raw.xsl $
$Revision: #1 $

 IBM Confidential
 OCO Source Materials
 BI and PM: Mobile
 (C) Copyright IBM Corp. 2007, 2009
 The source code for this program is not published or otherwise divested of its trade secrets, irrespective of what has been deposited with the U.S. Copyright Office.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:ccs="http://developer.cognos.com/rds/1"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bus="http://developer.cognos.com/schemas/bibus/3/">
	<xsl:output method="xml" omit-xml-declaration="yes" encoding="UTF-8" version="1.0"/>
	<xsl:param name="dataFmt">formattedData</xsl:param>
	<xsl:template match="/">
		<ccs:reportData>
			<!-- The root object may or may not exist-->
			<xsl:for-each select="root/Document/DATA/PAGE">
				<xsl:apply-templates select="."/>
			</xsl:for-each>
			<xsl:for-each select="Document/DATA/PAGE">
				<xsl:apply-templates select="."/>
			</xsl:for-each>
			
			<!-- SFJ: include drill data -->
			<xsl:for-each select="root/Document/DRILLS">
				<xsl:apply-templates select="."/>
			</xsl:for-each>
			<xsl:for-each select="Document/DRILLS">
				<xsl:apply-templates select="."/>
			</xsl:for-each>
		</ccs:reportData>
	</xsl:template>
	<xsl:template match="LIST">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:if test="@layoutClass = 'list' ">
			<xsl:element name="{$reloc}">
				<ccs:id>
					<xsl:choose>
						<xsl:when test="@name">
							<xsl:value-of select="@name"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$locid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ccs:id>
				<ccs:style/>
				<ccs:name>
					<xsl:value-of select="@name"/>
				</ccs:name>
				<ccs:type>Table</ccs:type>
				<ccs:content>
					<ccs:table>
						<xsl:apply-templates select="DR"/>
						<xsl:call-template name="styles"/>
					</ccs:table>
				</ccs:content>
			</xsl:element>
		</xsl:if>
		<xsl:if test="@layoutClass = 'crosstab' ">
			<xsl:element name="{$reloc}">
				<ccs:id>
					<xsl:choose>
						<xsl:when test="@name">
							<xsl:value-of select="@name"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$locid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ccs:id>
				<ccs:style/>
				<ccs:name>
					<xsl:value-of select="@name"/>
				</ccs:name>
				<ccs:type>Table</ccs:type>
				<ccs:content>
					<ccs:table>
						<xsl:apply-templates select="DR"/>
						<xsl:call-template name="styles"/>
					</ccs:table>
				</ccs:content>
			</xsl:element>
		</xsl:if>
		<xsl:if test="@layoutClass = 'table' ">
			<!-- SFJ: layout tables -->
			<xsl:element name="{$reloc}">
				<ccs:id>
					<xsl:choose>
						<xsl:when test="@name">
							<xsl:value-of select="@name"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$locid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ccs:id>
				<ccs:style/>
				<ccs:name>
					<xsl:value-of select="@name"/>
				</ccs:name>
				<ccs:type>Table</ccs:type>
				<ccs:content>
					<ccs:table>
						<ccs:isLayout>1</ccs:isLayout>
						<xsl:apply-templates select="OTR">
							<xsl:with-param name="locid">
								<xsl:value-of select="concat($locid,'T',position())"/>
							</xsl:with-param>
							<xsl:with-param name="reloc">
								<xsl:value-of select="$reloc"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:call-template name="styles"/>
					</ccs:table>
				</ccs:content>
			</xsl:element>
			<!-- SFJ: take out for now
			<xsl:for-each select="DR/DRI/*[local-name() != 'OMAP']">
				<xsl:apply-templates select=".">
					<xsl:with-param name="locid">
						<xsl:value-of select="concat($locid,'T',position())"/>
					</xsl:with-param>
					<xsl:with-param name="reloc">
						<xsl:value-of select="$reloc"/>
					</xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each>
			<xsl:for-each select="OTR/DRI/*[local-name() != 'OMAP']">
				<xsl:apply-templates select=".">
					<xsl:with-param name="locid">
						<xsl:value-of select="concat($locid,'T',position())"/>
					</xsl:with-param>
					<xsl:with-param name="reloc">
						<xsl:value-of select="$reloc"/>
					</xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each>
			-->
		</xsl:if>
		<xsl:if test="@layoutClass = 'repeaterTable' ">
			<xsl:element name="{$reloc}">
				<ccs:id>
					<xsl:choose>
						<xsl:when test="@name">
							<xsl:value-of select="@name"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$locid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ccs:id>
				<ccs:type>Table</ccs:type>
				<ccs:content>
					<ccs:table>
						<ccs:isLayout>0</ccs:isLayout>
						<xsl:apply-templates select="UNKNOWN">
							<xsl:with-param name="locid">
								<xsl:value-of select="concat($locid,'RT',position())"/>
							</xsl:with-param>
							<xsl:with-param name="reloc">
								<xsl:value-of select="$reloc"/>
							</xsl:with-param>
						</xsl:apply-templates>
						<xsl:call-template name="styles"/>
					</ccs:table>
				</ccs:content>
			</xsl:element>
		</xsl:if>
	</xsl:template>
	<xsl:template match="UNKNOWN">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:choose>
			<xsl:when test="@layoutClass = 'repeaterTableRow'">
				<xsl:choose>
					<xsl:when test="DRI[@layoutClass='repeaterTableCell']">
						<ccs:row>
							<xsl:for-each select="DRI[@layoutClass='repeaterTableCell']">
								<ccs:cells>
									<xsl:for-each select="*">
										<xsl:apply-templates select=".">
											<xsl:with-param name="reloc">ccs:parts</xsl:with-param>
										</xsl:apply-templates>
									</xsl:for-each>
								</ccs:cells>
							</xsl:for-each>
							<xsl:call-template name="styles"/>
						</ccs:row>
					</xsl:when>
					<xsl:otherwise>
						<!-- legitimately 'unknown', so proceed as before... -->
						<xsl:for-each select="*">
							<xsl:apply-templates select=".">
								<xsl:with-param name="locid">
									<xsl:value-of select="$locid"/>
								</xsl:with-param>
								<xsl:with-param name="reloc">
									<xsl:value-of select="$reloc"/>
								</xsl:with-param>
							</xsl:apply-templates>
						</xsl:for-each>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- Just in case the UNKNOWN element reappears again.
			<xsl:when test="@layoutClass = 'table'">
				<xsl:param name="locid"/>
				<xsl:param name="reloc"/>
				<xsl:for-each select="OTR/DRI/*">
					<xsl:apply-templates select=".">
						<xsl:with-param name="locid">
							<xsl:value-of select="concat($locid,'T',position())"/>
						</xsl:with-param>
						<xsl:with-param name="reloc">
							<xsl:value-of select="$reloc"/>
						</xsl:with-param>
					</xsl:apply-templates>
				</xsl:for-each>
			</xsl:when>
			-->
		</xsl:choose>
	</xsl:template>
	<xsl:template match="OFLDSET">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:for-each select="*[local-name() != 'OCAPTION']">
			<xsl:apply-templates select=".">
				<xsl:with-param name="locid">
					<xsl:value-of select="concat($locid,'P',position())"/>
				</xsl:with-param>
				<xsl:with-param name="reloc">
					<xsl:value-of select="$reloc"/>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="FORM|OTD">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:if test="@layoutClass = 'block' ">
			<xsl:for-each select="./*[local-name() != 'OMAP']">
				<xsl:apply-templates select=".">
					<xsl:with-param name="locid">
						<xsl:value-of select="concat($locid,'P',position())"/>
					</xsl:with-param>
					<xsl:with-param name="reloc">
						<xsl:value-of select="$reloc"/>
					</xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="@layoutClass = 'pageHeader' ">
			<!-- SFJ: no longer explicitly skip over layout table children, and added maps -->
			<!-- <xsl:for-each select="LIST[@layoutClass='table']/DR/DRI/*[local-name() != 'OMAP'] | LIST[@layoutClass='list'] | LIST[@layoutClass='repeaterTable'] | LIST[@layoutClass='crosstab'] | OTI | OIMG | FORM |LIST[@layoutClass='table']/OTR/DRI/*[local-name() != 'OMAP']|OCHART|OFLDSET"> -->
			<xsl:for-each select="LIST[@layoutClass='table'] | LIST[@layoutClass='list'] | LIST[@layoutClass='repeaterTable'] | LIST[@layoutClass='crosstab'] | drillTargets | OTI | OHTML | OIMG | FORM | OCHART | OFLDSET | OMAP[@layoutClass='chart_map']">
				<xsl:apply-templates select=".">
					<xsl:with-param name="locid">
						<xsl:value-of select="concat($locid,':H',position())"/>
					</xsl:with-param>
					<xsl:with-param name="reloc">ccs:headerElements</xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="@layoutClass = 'pageBody'">
			<!-- SFJ: no longer explicitly skip over layout table children, and added maps -->
			<!-- <xsl:for-each select="LIST[@layoutClass='table']/DR/DRI/*[local-name() != 'OMAP'] | LIST[@layoutClass='list'] | LIST[@layoutClass='repeaterTable'] | LIST[@layoutClass='crosstab'] | OTI | OIMG | FORM |LIST[@layoutClass='table']/OTR/DRI/*[local-name() != 'OMAP']|OCHART|OFLDSET"> -->
			<xsl:for-each select="LIST[@layoutClass='table'] | LIST[@layoutClass='list'] | LIST[@layoutClass='repeaterTable'] | LIST[@layoutClass='crosstab'] | drillTargets | OTI | OHTML | OIMG | FORM | OCHART | OFLDSET | OMAP[@layoutClass='chart_map']">
				<xsl:apply-templates select=".">
					<xsl:with-param name="locid">
						<xsl:value-of select="concat($locid,':B',position())"/>
					</xsl:with-param>
					<xsl:with-param name="reloc">ccs:bodyElements</xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="@layoutClass = 'pageFooter'">
			<!-- SFJ: no longer explicitly skip over layout table children, and added maps -->
			<!-- <xsl:for-each select="LIST[@layoutClass='table']/DR/DRI/*[local-name() != 'OMAP'] | LIST[@layoutClass='list'] | LIST[@layoutClass='repeaterTable'] | LIST[@layoutClass='crosstab'] | OTI | OIMG | FORM |LIST[@layoutClass='table']/OTR/DRI/*[local-name() != 'OMAP']|OCHART|OFLDSET"> -->
			<xsl:for-each select="LIST[@layoutClass='table'] | LIST[@layoutClass='list'] | LIST[@layoutClass='repeaterTable'] | LIST[@layoutClass='crosstab'] | drillTargets | OTI | OHTML | OIMG | FORM | OCHART | OFLDSET | OMAP[@layoutClass='chart_map']">
				<xsl:apply-templates select=".">
					<xsl:with-param name="locid">
						<xsl:value-of select="concat($locid,':F',position())"/>
					</xsl:with-param>
					<xsl:with-param name="reloc">ccs:footerElements</xsl:with-param>
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	<xsl:template match="PAGE">
		<xsl:variable name="locid">
			<xsl:choose>
				<xsl:when test="@name">
					<xsl:value-of select="@name"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat('page_',position())"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<ccs:pages>
			<ccs:id>
				<xsl:value-of select="$locid"/>
			</ccs:id>
			<ccs:name>
				<xsl:if test="@name">
					<xsl:value-of select="$locid"/>
				</xsl:if>
			</ccs:name>
			<ccs:type>Page</ccs:type>
			<ccs:content>
				<ccs:page>
					<xsl:apply-templates>
						<xsl:with-param name="locid">
							<xsl:value-of select="$locid"/>
						</xsl:with-param>
					</xsl:apply-templates>
				</ccs:page>
			</ccs:content>
			<xsl:if test="../../styleOptions/cssUrl">
				<ccs:unprocessedStyle>
					<xsl:value-of select="../../styleOptions/cssUrl"/>
				</ccs:unprocessedStyle>
			</xsl:if>
			<xsl:if test="../../styleOptions/namedCssStyleText">
				<ccs:namedCssStyleText>
					<xsl:value-of select="../../styleOptions/namedCssStyleText"/>
				</ccs:namedCssStyleText>

			</xsl:if>

		</ccs:pages>
	</xsl:template>
	<xsl:template match="DR">
		<ccs:row>
			<xsl:variable name="isCrosstabHeader">
				<xsl:choose>
					<xsl:when test="@layoutClass = 'crosstabColumns'">1</xsl:when>
					<xsl:otherwise>0</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<ccs:type>
				<xsl:variable name="rowtype">
					<xsl:value-of select="@type"/>
				</xsl:variable>
				<xsl:choose>
					<xsl:when test="$isCrosstabHeader = '1'">Header</xsl:when>
					<xsl:when test="$rowtype = 'header'">Header</xsl:when>
					<xsl:when test="$rowtype = 'footer'">Footer</xsl:when>
					<xsl:otherwise>Detail</xsl:otherwise>
				</xsl:choose>
			</ccs:type>
			<xsl:for-each select="DRI">
				<ccs:cells>
					<!-- SFJ: my test for list/crosstab titles -->
					<xsl:variable name="isTitle">
						<xsl:choose>
							<xsl:when test="@type = 'columnTitle'">1</xsl:when>
							<xsl:when test="@layoutClass = 'listColumnTitle'">1</xsl:when>
							<xsl:otherwise>0</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<ccs:type>
						<xsl:choose>
							<xsl:when test="$isTitle = '1'">Title</xsl:when>
							<xsl:otherwise>Value</xsl:otherwise>
						</xsl:choose>
					</ccs:type>
				
					<!-- for an empty crosstab corner, create a textframe, with the spans and styles of the corner -->
					<xsl:if test="@layoutClass = 'crosstabCorner' and count(*) = 0">
						<ccs:parts>
							<ccs:id/>
							<xsl:if test="@rowspan">
								<ccs:rowspan>
									<xsl:value-of select="@rowspan"/>
								</ccs:rowspan>
							</xsl:if>
							<xsl:if test="@colspan">
								<ccs:colspan>
									<xsl:value-of select="@colspan"/>
								</ccs:colspan>
							</xsl:if>
							<ccs:type>TextFrame</ccs:type>
							<ccs:content>
								<ccs:textFrame>
									<ccs:value/>
									<ccs:dataFormat/>
									<ccs:valueType>text</ccs:valueType>
								</ccs:textFrame>
							</ccs:content>
							<xsl:call-template name="styles"/>
						</ccs:parts>
					</xsl:if>
					<xsl:for-each select="*">
						<xsl:apply-templates select=".">
							<xsl:with-param name="reloc">ccs:parts</xsl:with-param>
						</xsl:apply-templates>
					</xsl:for-each>
				</ccs:cells>
			</xsl:for-each>
		</ccs:row>
	</xsl:template>
	<xsl:template match="OIMG ">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<!-- temp fix for handling QS sort indicator images in COC -->
		<xsl:if test="$reloc != 'parts' or count(../*) &lt; 2">
			<xsl:element name="{$reloc}">
				<ccs:id>
					<xsl:choose>
						<xsl:when test="@name">
							<xsl:value-of select="@name"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$locid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ccs:id>
				<ccs:type>Image</ccs:type>
				<ccs:content>
					<ccs:image>
<xsl:if test="drillTargets">
								<xsl:for-each select="drillTargets/drillTarget">
									<ccs:drillTarget>
										<ccs:drillIndex><xsl:value-of select="@drillIdx"/></ccs:drillIndex>
										<xsl:for-each select="drillParameter">
											<ccs:drillParameter>
												<ccs:name><xsl:value-of select="@name"/></ccs:name>
												<ccs:value><xsl:value-of select="@value"/></ccs:value>
												<ccs:mun><xsl:value-of select="@mun"/></ccs:mun>
											</ccs:drillParameter>
										</xsl:for-each>
									</ccs:drillTarget>
								</xsl:for-each>
							</xsl:if>
						<ccs:url>
							<xsl:choose>
								<xsl:when test="starts-with(@src,'http')">
									<xsl:value-of select="@src"/>
								</xsl:when>
								<xsl:when test="starts-with(@src,'file')">
									<xsl:value-of select="@src"/>
								</xsl:when>
								<xsl:otherwise>
									<ccs:unprocessedGateway>
										<xsl:choose>
											<xsl:when test="starts-with(@src,'?')">
												<xsl:value-of select="@src"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="concat('/../', @src)"/>
											</xsl:otherwise>
										</xsl:choose>
									</ccs:unprocessedGateway>
								</xsl:otherwise>
							</xsl:choose>
						</ccs:url>
					</ccs:image>
					<ccs:style/>
				</ccs:content>
			</xsl:element>
		</xsl:if>
		<xsl:call-template name="styles"/>
	</xsl:template>
	<!-- SFJ: chart map support -->
	<xsl:template match="OMAP">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:element name="{$reloc}">
			<ccs:type>Map</ccs:type>
			<ccs:content>
				<ccs:map>
					<ccs:id><xsl:value-of select="@name"/></ccs:id>
					<xsl:for-each select="OAREA">
					<!--support MAP based Drill-Through-->
						<xsl:if test="@title | drillTargets">
							<ccs:area>
								<xsl:if test="drillTargets">
								<xsl:for-each select="drillTargets/drillTarget">
									<ccs:drillTarget>
										<ccs:drillIndex><xsl:value-of select="@drillIdx"/></ccs:drillIndex>
										<xsl:for-each select="drillParameter">
											<ccs:drillParameter>
												<ccs:name><xsl:value-of select="@name"/></ccs:name>
												<ccs:value><xsl:value-of select="@value"/></ccs:value>
												<ccs:mun><xsl:value-of select="@mun"/></ccs:mun>
											</ccs:drillParameter>
										</xsl:for-each>
									</ccs:drillTarget>
								</xsl:for-each>
							</xsl:if>
								<ccs:label><xsl:value-of select="@title"/></ccs:label>
								<xsl:if test="@shape='POLY'">
									<ccs:poly><xsl:value-of select="@coords"/></ccs:poly>
								</xsl:if>

							</ccs:area>
						</xsl:if>	
					</xsl:for-each>
				</ccs:map>
			</ccs:content>
		</xsl:element>
	</xsl:template>
	<xsl:template match="OCHART">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:element name="{$reloc}">
			<ccs:id>
				<xsl:choose>
					<xsl:when test="@name">
						<xsl:value-of select="@name"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$locid"/>
					</xsl:otherwise>
				</xsl:choose>
			</ccs:id>
			<ccs:type>Chart</ccs:type>
			<ccs:content>
				<ccs:chart>
					<ccs:imageUrl>
						<xsl:choose>
							<xsl:when test="starts-with(@src,'http')">
								<xsl:value-of select="@src"/>
							</xsl:when>
							<xsl:when test="starts-with(@src,'file')">
								<xsl:value-of select="@src"/>
							</xsl:when>
							<xsl:otherwise>
								<ccs:unprocessedGateway>
									<xsl:choose>
										<xsl:when test="starts-with(@src,'?')">
											<xsl:value-of select="@src"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="concat('/../', @src)"/>
										</xsl:otherwise>
									</xsl:choose>
								</ccs:unprocessedGateway>
							</xsl:otherwise>
						</xsl:choose>
					</ccs:imageUrl>
					<!-- SFJ: the size and map of this chart -->
					<ccs:imageWidth><xsl:value-of select="@chart_width" /></ccs:imageWidth>
					<ccs:imageHeight><xsl:value-of select="@chart_height" /></ccs:imageHeight>
					<ccs:imageMap><xsl:value-of select="@usemap" /></ccs:imageMap>
				</ccs:chart>
				<ccs:style/>
			</ccs:content>
		</xsl:element>
	</xsl:template>
	<xsl:template match="OTR">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>

		<xsl:choose>
			<!-- generate a layout table row if we have cells -->
			<xsl:when test="DRI[@layoutClass='tableCell']">
				<ccs:row>
						<!-- generate a ccs:parts element for each table cell -->
						<xsl:for-each select="DRI[@layoutClass='tableCell']">
							<ccs:cells>
								<ccs:id/>
								<xsl:if test="@rowspan">
									<ccs:rowspan>
										<xsl:value-of select="@rowspan"/>
									</ccs:rowspan>
								</xsl:if>
								<xsl:if test="@colspan">
									<ccs:colspan>
										<xsl:value-of select="@colspan"/>
									</ccs:colspan>
								</xsl:if>

								<xsl:for-each select="*">
									<xsl:apply-templates select=".">
										<xsl:with-param name="reloc">ccs:parts</xsl:with-param>
									</xsl:apply-templates>
								</xsl:for-each>
							</ccs:cells>
						</xsl:for-each>
						<xsl:call-template name="styles"/>
				</ccs:row>
			</xsl:when>
			<xsl:otherwise>
				<!-- not a layout table, so proceed as before... -->
				<xsl:for-each select="*">
					<xsl:apply-templates select=".">
						<xsl:with-param name="locid">
							<xsl:value-of select="$locid"/>
						</xsl:with-param>
						<xsl:with-param name="reloc">
							<xsl:value-of select="$reloc"/>
						</xsl:with-param>
					</xsl:apply-templates>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="drillTargets">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:for-each select="OTI | OHTML">
			<xsl:apply-templates select=".">
				<xsl:with-param name="reloc">
					<xsl:value-of select="$reloc"/>
				</xsl:with-param>
			</xsl:apply-templates>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="OCAPTION">
		<!-- Do nothing with fieldset captions-->
	</xsl:template>
	<xsl:template match="OTI | OHTML">
		<xsl:param name="locid"/>
		<xsl:param name="reloc"/>
		<xsl:if test="not(@style = 'visibility:hidden')">
			<xsl:element name="{$reloc}">
				<ccs:id>
					<xsl:choose>
						<xsl:when test="@name">
							<xsl:value-of select="@name"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$locid"/>
						</xsl:otherwise>
					</xsl:choose>
				</ccs:id>
				<xsl:choose>
					<xsl:when test="../../drillTargets">
						<xsl:if test="../../@rowspan">
							<ccs:rowspan>
								<xsl:value-of select="../../@rowspan"/>
							</ccs:rowspan>
						</xsl:if>
					</xsl:when>
					<xsl:when test="../../../../@rowspan and ../../../@layoutClass='table'">
						<ccs:rowspan>
							<xsl:value-of select="../../../../@rowspan"/>
						</ccs:rowspan>
					</xsl:when>
					<xsl:when test="../@rowspan">
						<ccs:rowspan>
							<xsl:value-of select="../@rowspan"/>
						</ccs:rowspan>
					</xsl:when>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="../../drillTargets">
						<xsl:choose>
							<xsl:when test="../../@colspan">
								<ccs:colspan>
									<xsl:value-of select="../../@colspan"/>
								</ccs:colspan>
							</xsl:when>
							<xsl:when test="../../@colSpan">
								<ccs:colspan>
									<xsl:value-of select="../../@colSpan"/>
								</ccs:colspan>
							</xsl:when>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="../../../../@colspan and ../../../@layoutClass='table'">
						<ccs:colspan>
							<xsl:value-of select="../../../../@colspan"/>
						</ccs:colspan>
					</xsl:when>
					<xsl:when test="../@colspan">
						<ccs:colspan>
							<xsl:value-of select="../@colspan"/>
						</ccs:colspan>
					</xsl:when>
					<xsl:when test="../@colSpan">
						<colspan>
							<xsl:value-of select="../@colSpan"/>
						</colspan>
					</xsl:when>
				</xsl:choose>
				<ccs:type>TextFrame</ccs:type>
				<ccs:content>
					<ccs:textFrame>
						<!-- SFJ: add the drill information -->
						<xsl:if test="parent::drillTargets">
							<xsl:for-each select="parent::drillTargets/drillTarget">
								<ccs:drillTarget>
									<ccs:drillIndex><xsl:value-of select="@drillIdx"/></ccs:drillIndex>
									<xsl:for-each select="drillParameter">
										<ccs:drillParameter>
											<ccs:name><xsl:value-of select="@name"/></ccs:name>
											<ccs:value><xsl:value-of select="@value"/></ccs:value>
											<ccs:mun><xsl:value-of select="@mun"/></ccs:mun>
										</ccs:drillParameter>
									</xsl:for-each>
								</ccs:drillTarget>
							</xsl:for-each>
						</xsl:if>
						<ccs:value>
							<xsl:choose>
								<xsl:when test="($dataFmt='formattedData') or (string-length(@RawXML) = 0 )">
									<xsl:value-of select="."/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:choose>
										<xsl:when test="@valueType = 'number' ">
											<xsl:value-of select="translate(@RawXML, ',', '.')"/>
										</xsl:when>
										<xsl:when test="@valueType = 'currency' ">
											<xsl:value-of select="translate(@RawXML, ',', '.')"/>
										</xsl:when>
										<xsl:when test="@valueType = 'percent' ">
											<xsl:value-of select="translate(@RawXML, ',', '.')"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="@RawXML"/>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:otherwise>
							</xsl:choose>
						</ccs:value>
						<ccs:dataFormat>
							<xsl:value-of select="@formatPatternExcel"/>
						</ccs:dataFormat>
						<ccs:valueType>
							<xsl:value-of select="@valueType"/>
						</ccs:valueType>
					</ccs:textFrame>
				</ccs:content>
				<xsl:call-template name="styles"/>
			</xsl:element>
		</xsl:if>
	</xsl:template>
	<xsl:template name="styles">
		<xsl:if test="not(../../../@layoutClass = 'list') and not(../../../@layoutClass = 'crosstab') and not(../../../@layoutClass = 'repeaterTable')">
		<xsl:if test="string-length(../../../@class) &gt;  0">
			<ccs:preProcessedStyle>
				<xsl:value-of select="../../../@class"/>
			</ccs:preProcessedStyle>
		</xsl:if>
		<xsl:if test="string-length(../../../@style) &gt;  0">
			<ccs:unprocessedStyle>
				<xsl:value-of select="../../../@style"/>
			</ccs:unprocessedStyle>
			</xsl:if>
		</xsl:if>
		<xsl:if test="string-length(../../@class) &gt;  0">
			<ccs:preProcessedStyle>
				<xsl:value-of select="../../@class"/>
			</ccs:preProcessedStyle>
		</xsl:if>
		<xsl:if test="string-length(../../@style) &gt;  0">
			<ccs:unprocessedStyle>
				<xsl:value-of select="../../@style"/>
			</ccs:unprocessedStyle>
		</xsl:if>
		<xsl:if test="string-length(../@class) &gt;  0">
			<ccs:preProcessedStyle>
				<xsl:value-of select="../@class"/>
			</ccs:preProcessedStyle>
		</xsl:if>
		<xsl:if test="string-length(../@style) &gt;  0">
			<ccs:unprocessedStyle>
				<xsl:value-of select="../@style"/>
			</ccs:unprocessedStyle>
		</xsl:if>
		<xsl:if test="string-length(@class) &gt;  0">
			<ccs:preProcessedStyle>
				<xsl:value-of select="@class"/>
			</ccs:preProcessedStyle>
		</xsl:if>
		<xsl:if test="string-length(@style) &gt;  0">
			<ccs:unprocessedStyle>
				<xsl:value-of select="@style"/>
			</ccs:unprocessedStyle>
		</xsl:if>
	</xsl:template>
	
	<!-- SFJ: drill-through support -->
	<xsl:template match="DRILL">
		<ccs:drill>
			<ccs:cmPath><xsl:value-of select="@path"/></ccs:cmPath>
			<ccs:label><xsl:value-of select="@label"/></ccs:label>
			<xsl:copy-of select="*"/>
			
		</ccs:drill>
	</xsl:template>
</xsl:stylesheet>
