package processors

import com.cognos.mobile.c8.C8PortalTree;
import com.cognos.mobile.common.C8;
import com.cognos.mobile.common.CMException;
import com.cognos.mobile.common.CMUrlConstants;
import com.cognos.mobile.common.CMUrlHelper;
import com.cognos.mobile.common.C8.PortalItem;
import com.cognos.mobile.server.core.SCRequest;
import com.cognos.mobile.server.core.SCResponse;
import com.cognos.mobile.server.core.SCUserSession;
import com.cognos.mobile.common.CMUrlConstants
import com.cognos.mobile.common.IInputStreamFactory
import com.cognos.mobile.server.bus.CPSService
import com.cognos.mobile.server.bus.IC8Configuration
import com.cognos.mobile.server.core.SCRequest
import com.cognos.mobile.server.core.SCResponse
import com.cognos.mobile.server.core.SCUserSession
import com.cognos.mobile.standardedition.DOM4JUtil
import com.cognos.mobile.c8.C8PortalTree;
import com.cognos.mobile.vm.VM;
import com.cognos.mobile.xml.XML;
import com.cognos.mobile.server.handler.SLHelper;
import groovy.xml.MarkupBuilder
import com.cognos.mobile.server.core.SCReportManager


def renderAsXML = { items, r ->
	StringBuffer result = new StringBuffer();
	if (items != null) {
		for (int i = 0; i < items.length; ++i) {
			// build the XML for the i-th item
			boolean renderExists = false;
			int n = items[i].sourcePath.lastIndexOf( "/" );
			String label = CMUrlHelper.decodeSourcePathElement(items[i].sourcePath.substring( n + 1 ));
			result.append(SLHelper.openTag(XML.XML_ITEM));
			result.append(SLHelper.openTag(XML.XML_LABEL));
			result.append(SLHelper.encodeXml(label));
			result.append(SLHelper.closeTag(XML.XML_LABEL));
			result.append(SLHelper.openTag(XML.XML_ITEMTYPE));
			switch (items[i].itemType) {
				case C8.ITEMTYPE_FOLDER :
				case C8.ITEMTYPE_PACKAGE :
					if( items[i].permissions != null ){
						List p = Arrays.asList( items[i].permissions);
						if( p.contains("traverse") && p.contains("execute")) result.append(XML.XML_ITEMTYPE_FOLDER);
					} else {
						result.append(XML.XML_ITEMTYPE_FOLDER);
					}
					break;
				case C8.ITEMTYPE_DASHBOARD:	
				case C8.ITEMTYPE_REPORT :
				case C8.ITEMTYPE_SHORTCUT:	
					if( items[i].permissions != null ){
						List p = Arrays.asList( items[i].permissions);
						if( p.contains("execute")){
							 if( p.contains("traverse") || p.contains("read")) result.append(XML.XML_ITEMTYPE_REPORT);
						}
					} else {
						result.append(XML.XML_ITEMTYPE_REPORT);
					}
					if( r.containsKey(items[i].cmPath )) renderExists = true;
					break;
					
			}
			result.append(SLHelper.closeTag(XML.XML_ITEMTYPE));
			result.append(SLHelper.openTag(XML.XML_MODIFIED));
			result.append(SLHelper.encodeXml( items[i].modificationTime));
			result.append(SLHelper.closeTag(XML.XML_MODIFIED));
			result.append(SLHelper.openTag(XML.XML_SOURCEPATH));
			result.append(SLHelper.encodeXml( items[i].sourcePath));
			result.append(SLHelper.closeTag(XML.XML_SOURCEPATH));
			result.append(SLHelper.openTag(XML.XML_STOREID));
			result.append(SLHelper.encodeXml( items[i].storeID));
			result.append(SLHelper.closeTag(XML.XML_STOREID));
			result.append(SLHelper.openTag(XML.XML_CMPATH));
			if (items[i].itemType == C8.ITEMTYPE_SHORTCUT)
				result.append(SLHelper.encodeXml(items[i].targetCMPath));
			else
				result.append(SLHelper.encodeXml(items[i].cmPath));
			result.append(SLHelper.closeTag(XML.XML_CMPATH));
			if( renderExists ) result.append( "<render>" + r.get(items[i].cmPath).getRenderID() + "</render>");
			result.append(SLHelper.closeTag(XML.XML_ITEM));
		}
	}
	return result.toString();
}

sourcepath = args["mob_rp"]

if( sourcepath == null )
	sourcepath = "/";
else if (! sourcepath.startsWith("/"))
	sourcepath = "/" + sourcepath;
C8PortalTree portalTree = session.browseC8PortalTree
PortalItem[] items = portalTree.find(sourcepath)

SCReportManager manager = new SCReportManager(isf, database, c8config, tmp)
def renders = database.browseRenders(session.userId, false)
def urenders = new LinkedHashMap()
renders.each{ rr ->
	//filter drill target reports;
	if (rr.sourceCode != 2){
		if( !urenders.containsKey(rr.getCMPath())) urenders.put( rr.getCMPath(), rr )
	}
}

return "<content>" + renderAsXML(items, urenders) + "</content>"
