// $Author: wangja $
// $DateTime: 2009/02/11 18:25:41 $
// $File: //mobile/main/prod/server/src/com/cognos/mobile/server/bus/MobileService.java $
// $Revision: #5 $
//
// Copyright 2008 Cognos ULC, an IBM Company.
package processors

import com.cognos.mobile.common.CMErrors;
import com.cognos.mobile.common.CMException;
import com.cognos.mobile.common.CMStringHelper;
import com.cognos.mobile.common.CMUrlConstants;
import com.cognos.mobile.location.ConfigParser;
import com.cognos.mobile.location.IReverseGeocoder;
import com.cognos.mobile.server.core.SCRequest;
import com.cognos.mobile.server.core.SCResponse;
import com.cognos.mobile.server.core.SCUserSession;
import com.cognos.mobile.server.handler.AboutHandler;
import com.cognos.mobile.server.handler.AdminHandler;
import com.cognos.mobile.server.handler.BrowseAtomFeedHandler;
import com.cognos.mobile.server.handler.BrowsePortalHandler;
import com.cognos.mobile.server.handler.BrowseTreePromptHandler;
import com.cognos.mobile.server.handler.CCSHandler;
import com.cognos.mobile.server.handler.ChunkedRequestHandler;
import com.cognos.mobile.server.handler.DashboardHandler;
import com.cognos.mobile.server.handler.DeleteRenderHandler;
import com.cognos.mobile.server.handler.DownloadDBHandler;
import com.cognos.mobile.server.handler.DownloadZoomHandler;
import com.cognos.mobile.server.handler.DrillThroughHandler;
import com.cognos.mobile.server.handler.GetKeyHandler;
import com.cognos.mobile.server.handler.GetSettingsHandler;
import com.cognos.mobile.server.handler.IHandler;
import com.cognos.mobile.server.handler.IPromptFiller;
import com.cognos.mobile.server.handler.ReverseGeocodeHandler;
import com.cognos.mobile.server.handler.RunReportHandler;
import com.cognos.mobile.server.handler.SearchHandler;
import com.cognos.mobile.server.handler.StatusHandler;
import com.cognos.mobile.server.handler.ViewRenderHandler;
import com.cognos.mobile.server.handler.ViewScheduleHandler;
import com.cognos.mobile.server.location.ReverseGeocodingPromptFiller;
import com.cognos.mobile.standardedition.DOM4JUtil;
import com.cognos.mobile.standardedition.StringUtil;
import com.cognos.mobile.vm.VM;
import com.cognos.mobile.server.handler.HistoryHandler;
import com.cognos.mobile.server.handler.ViewScheduleHandler;
import com.cognos.mobile.server.handler.MRVHandler;
import com.cognos.mobile.server.handler.SearchHandler;
import com.cognos.mobile.server.handler.DrillThroughHandler;
import com.cognos.mobile.server.handler.DrillUpDownHandler;
import com.cognos.mobile.server.handler.FavouriteHandler;

def CLASS = getClass();

VM.log(CLASS, VM.SEVERITY_DEBUG, "reading location configuration");
IReverseGeocoder reverseGeocoder = ConfigParser.parse(mobileService.getC8Configuration().getConfigurationDirectory() + "/mobile", "location.xml");
if (reverseGeocoder != null) {
	controller.setLocationPromptFiller(new ReverseGeocodingPromptFiller(reverseGeocoder));
	controller.registerHandler(CMUrlConstants.SERVLET_GEO, new ReverseGeocodeHandler(reverseGeocoder));
	VM.log(CLASS, VM.SEVERITY_DEBUG, "configured reverse-geocoding prompt-filler");
} else {
	controller.setLocationPromptFiller(null);
	VM.log(CLASS, VM.SEVERITY_DEBUG, "no reverse-geocoder specified in location.xml; no prompt-filler configured");
}

controller.registerHandler(CMUrlConstants.SERVLET_ABOUT, new AboutHandler());
controller.registerHandler(CMUrlConstants.SERVLET_BROWSE_PORTAL, new BrowsePortalHandler());
controller.registerHandler(CMUrlConstants.SERVLET_BROWSE_TREE_PROMPT, new BrowseTreePromptHandler(mobileService.getC8Configuration(), mobileService.getInputStreamFactory()));
controller.registerHandler(CMUrlConstants.SERVLET_COMPILE_REPORT, new RunReportHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getThreadPool(), controller.getLocationPromptFiller()));
controller.registerHandler(CMUrlConstants.SERVLET_DELETE_RENDER, new DeleteRenderHandler(mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore()));
controller.registerHandler(CMUrlConstants.SERVLET_DOWNLOAD_DB, new DownloadDBHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore()));
controller.registerHandler(CMUrlConstants.SERVLET_DOWNLOAD_ZOOM, new DownloadZoomHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore()));
controller.registerHandler(CMUrlConstants.SERVLET_GET_SETTINGS, new GetSettingsHandler(mobileService.getSCConfiguration()));
controller.registerHandler(CMUrlConstants.SERVLET_SEARCH, new SearchHandler(mobileService.getSCConfiguration(), mobileService.getC8Configuration()));
controller.registerHandler(CMUrlConstants.SERVLET_CCS, new CCSHandler(mobileService.getC8Configuration(), mobileService.getInputStreamFactory()));
controller.registerHandler(CMUrlConstants.SERVLET_CHUNKREQUEST, new ChunkedRequestHandler(mobileService.getDatabase()));
controller.registerHandler(CMUrlConstants.SERVLET_STATUS, new StatusHandler());
controller.registerHandler(CMUrlConstants.SERVLET_DRILLTHROUGH, new DrillThroughHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getThreadPool()));
controller.registerHandler(CMUrlConstants.SERVLET_DRILL_UP_DOWN, new DrillUpDownHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getThreadPool()));
controller.registerHandler(CMUrlConstants.SERVLET_ADMIN, new AdminHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getSessionCache()));
controller.registerHandler(CMUrlConstants.SERVLET_GET_KEY, new GetKeyHandler(mobileService.getSCConfiguration(), mobileService.getDatabase()));
controller.registerHandler(CMUrlConstants.SERVLET_VIEW_RENDER, new ViewRenderHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getThreadPool(), controller.getLocationPromptFiller()));
controller.registerHandler(CMUrlConstants.SERVLET_BROWSE_ATOM_FEED, new BrowseAtomFeedHandler(mobileService.getC8Configuration(), mobileService.getInputStreamFactory()));
controller.registerHandler(CMUrlConstants.SERVLET_DASHBOARD, new DashboardHandler(mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore()));
controller.registerHandler(CMUrlConstants.SERVLET_FAVOURITE, new FavouriteHandler(mobileService.getDatabase()));

// IMPORTANT NOTE!
// Ordering of registration of handlers is significant
// you will want to put the least likely match first.  Example, /user/inbox/2 before /user/inbox
// otherwise the wrong handler may try to intercept the call

def formats = "($CMUrlConstants.FORMAT_HTML)|($CMUrlConstants.FORMAT_JSON)|($CMUrlConstants.FORMAT_XML)"
controller.registerHandler( "$controller.MOBILESERVICE/user/home\\.?($formats)?", ["format"], "processors/user.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/namespace\\.?($formats)?", ["format"], "processors/user.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/inbox/(\\d+)\\.?($formats)?", ["renderId", "format"], "processors/user.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/inbox/(cm:|source:)(.*)", ["type", "id"], "processors/user.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/inbox\\.?($formats)?", ["format"], "processors/user.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/dashboard/(\\d+)\\.?($formats)?", ["renderId", "format"], "processors/user.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/fav/(.*?)\\.?($formats)?", ["storeId", "format"], "processors/user.groovy");

controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/pages/(\\d+)/thumb\\.?(($CMUrlConstants.IMAGEFORMAT_PNG))?", ["renderId", "page", "format"], "processors/render.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/pages/(\\d+)/dashboard\\.?(($CMUrlConstants.IMAGEFORMAT_PNG))?", ["renderId", "page", "format"], "processors/render.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/pages/(\\d+)\\.?(($CMUrlConstants.FORMAT_HTML))?", ["renderId", "page", "format"], "processors/render.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/images/(\\d+)\\.?(($CMUrlConstants.IMAGEFORMAT_JPEG)|($CMUrlConstants.IMAGEFORMAT_PNG)|($CMUrlConstants.IMAGEFORMAT_SVG))?", ["renderId", "blobId", "format"], "processors/render.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/charts/(\\d+)\\.?(($CMUrlConstants.IMAGEFORMAT_JPEG)|($CMUrlConstants.IMAGEFORMAT_PNG)|($CMUrlConstants.IMAGEFORMAT_SVG)|($CMUrlConstants.IMAGEFORMAT_HTML))?", ["renderId", "blobId", "format"], "processors/render.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/tables/(\\d+)\\.?(($CMUrlConstants.FORMAT_HTML)|($CMUrlConstants.IMAGEFORMAT_PNG))?", ["renderId", "blobId", "format"], "processors/render.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/renders/(\\d+)/session/.*\\.?(json)", ["renderId","format"], "processors/render.groovy");

//controller.registerHandler( "$controller.MOBILESERVICE/user/history/page/(\\d+)\\.?($formats)?", ["page", "format"], "processors/history.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/user/schedules/upcoming\\.?($formats)?", ["format"], new ViewScheduleHandler( mobileService.getDatabase(), mobileService.getC8Configuration(), mobileService.getScheduler().getC8EventManager()));

controller.registerHandler( "$controller.MOBILESERVICE/report/drillthrough/\\.($formats)?", ["format"], "processors/report.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/report/ccs/(.*?)/(.*?)\\.?($formats)?", ["storeId", "ccspath", "format"], "processors/report.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/report/details/(.*?)\\.?($formats)?", ["storeId", "format"], "processors/report.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/report/(.*?)\\.?($formats)?", ["storeId", "format"], "processors/report.groovy");


//controller.registerHandler( "$controller.MOBILESERVICE/history\\.?($formats)?", ["format"], "processors/history.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/cm/(.*?)\\.?($formats)?", ["cmpath", "format"], "processors/cm.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/about\\.?($formats)?", ["format"], "processors/about.groovy");
controller.registerHandler( "$controller.MOBILESERVICE/output/(\\d+)/page/(\\d+)\\.?($formats)?", [CMUrlConstants.PARAM_RENDERID[0], CMUrlConstants.PARAM_PAGE_INDEX[0], CMUrlConstants.PARAM_RENDER_OUTPUT_FORMAT[0]], new ViewRenderHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getThreadPool(), controller.getLocationPromptFiller()));

controller.registerHandler("$controller.MOBILESERVICE/content\\.?(xml|json)?", [CMUrlConstants.PARAM_FORMAT[0]], "processors/content.groovy");
// controller.registerHandler("$controller.MOBILESERVICE/content/([/a-zA-Z0-9]*)\\.?(xml|json)?", [CMUrlConstants.PARAM_ATOM_LINK[0],CMUrlConstants.PARAM_FORMAT[0]], "processors/content.groovy");
controller.registerHandler("$controller.MOBILESERVICE/content/(.+?)\\.?(xml|json)?", ["sourcepath", "format"], "processors/content.groovy");

formats = "(($CMUrlConstants.IMAGEFORMAT_PNG)|($CMUrlConstants.IMAGEFORMAT_JPEG)|($CMUrlConstants.IMAGEFORMAT_HTML))"
DownloadZoomHandler dzh = new DownloadZoomHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore());
controller.registerHandler("$controller.MOBILESERVICE/zoom/output/(\\d+)\\.?($formats)?", [CMUrlConstants.PARAM_RENDERID[0], "format"], dzh);
controller.registerHandler("$controller.MOBILESERVICE/zoom/output/(\\d+)/width/(\\d+)\\.?($formats)?", [ CMUrlConstants.PARAM_RENDERID[0], "width", "format" ], dzh);
controller.registerHandler("$controller.MOBILESERVICE/zoom/output/(\\d+)/height/(\\d+)\\.?($formats)?", [ CMUrlConstants.PARAM_RENDERID[0], "height" ], dzh);

HistoryHandler hh = new HistoryHandler(mobileService.getDatabase());
controller.registerHandler("$controller.MOBILESERVICE/history/(short|full)/(first|rest)?\\.?(xml|json)?", [CMUrlConstants.PARAM_HISTORY_LIST_TYPE[0], CMUrlConstants.PARAM_HISTORY_START[0],CMUrlConstants.PARAM_FORMAT[0]], hh);
controller.registerHandler("$controller.MOBILESERVICE/history/(en|cs|de|es|fi|fr|hu|it|ja|nl|pl|pt|ro|ru|sv|tr|zh-cn)/(short|full)/(first|rest)?\\.?(xml|json)?", [CMUrlConstants.PARAM_HISTORY_LANG[0],CMUrlConstants.PARAM_HISTORY_LIST_TYPE[0], CMUrlConstants.PARAM_HISTORY_START[0],CMUrlConstants.PARAM_FORMAT[0]], hh);

ViewScheduleHandler vsh = new ViewScheduleHandler(mobileService.getDatabase(),mobileService.getC8Configuration(),mobileService.getScheduler().getC8EventManager());
controller.registerHandler("$controller.MOBILESERVICE/upcoming/(first|rest)\\.?(xml|json)?", [CMUrlConstants.PARAM_SCHEDULE_START[0],CMUrlConstants.PARAM_FORMAT[0]], vsh);

MRVHandler mrvh = new MRVHandler(mobileService.getDatabase());
controller.registerHandler("$controller.MOBILESERVICE/mrv\\.?(xml|json)?", [CMUrlConstants.PARAM_FORMAT[0]], mrvh);

SearchHandler sh = new SearchHandler(mobileService.getSCConfiguration(),mobileService.getC8Configuration());
controller.registerHandler("$controller.MOBILESERVICE/search\\.?(xml|json)", [CMUrlConstants.PARAM_FORMAT[0]], sh);

DrillThroughHandler dth = new DrillThroughHandler(mobileService.getSCConfiguration(), mobileService.getDatabase(), mobileService.getInputStreamFactory(), mobileService.getC8Configuration(), mobileService.getTmpStore(), mobileService.getThreadPool());
controller.registerHandler("$controller.MOBILESERVICE/drillThrough/(.*)\\.(html|xml)", [CMUrlConstants.PARAM_CONTEXT_XML[0],CMUrlConstants.PARAM_RENDER_OUTPUT_FORMAT[0]], dth);

