// $Author$
// $DateTime$
// $File$
// $Revision$
//
// Copyright 2005-2006 Cognos, Inc.
package processors

import com.cognos.mobile.server.core.SCResponse
import com.cognos.mobile.common.CMException;
import com.cognos.mobile.common.CMErrors;
import com.cognos.mobile.common.CMUrlConstants;
import com.cognos.mobile.vm.VM
import com.cognos.mobile.vm.IVMWriter
import com.cognos.mobile.server.core.SCReportManager
import com.cognos.mobile.server.core.ReportRenderer
import com.cognos.mobile.database.DBHistoryLogger
import com.cognos.mobile.database.RenderRow;
import com.cognos.mobile.generator.html.HtmlGrammar;
import com.cognos.mobile.common.IHistoryLogger
import com.cognos.mobile.standardedition.InputStreamFactory
import com.cognos.mobile.jzlib.ZInputStream
import java.io.ByteArrayInputStream
import groovy.xml.MarkupBuilder;

def m = ( path =~ /\/renders\/\d+\/?(.*)$/)
path = m[0][1]
def renderId = Integer.valueOf(args["renderId"]);

if (renderId != 0 && !database.renderIsInUsersInbox(renderId, session.userId )) 
	throw new CMException(CMErrors.SERVER_RENDER_NOT_FOUND, "This item is not available on the server.  Perhaps it was deleted?");
def fmt = format ?: "html"

switch( path ){
	case ~/pages\/\d+\/thumb/:
		def reportRenderer = new ReportRenderer(scconfig, database, isf, c8config, tmp)
		return SCResponse.fromBytes(reportRenderer.getThumbnail(renderId), mimetype);
	
	case ~/pages\/\d+\/dashboard/:
		def reportRenderer = new ReportRenderer(scconfig, database, isf, c8config, tmp)
		return SCResponse.fromBytes(reportRenderer.getDashboard(renderId), mimetype);
		
	case ~/pages\/\d+/ :
		def page = args["page"] == null ? 1 : Integer.valueOf(args["page"])
		renderId = Integer.valueOf(args["renderId"])
		def renderSize = database.getRenderSize(renderId)
		def reportRenderer = new ReportRenderer(scconfig, database, isf, c8config, tmp)
		def htmlBytes = reportRenderer.getPage(session, request, renderId, fmt, page)
		def logger = new DBHistoryLogger(database)
		if( htmlBytes == null ) throw new CMException(CMErrors.GENERIC, "Report result is null")
		def html = new String(htmlBytes, "UTF-8")
		
		def meta = "<meta content=\"" + renderSize + "\" name=\"${HtmlGrammar.META_PAGECOUNT}\"/>"
		def db = database.getDashboard(session.userId)
		if( db != null && renderId == db.renderID) meta += "<meta content=\"true\" name=\"${HtmlGrammar.META_ISDASHBOARD}\"/>"
		def favs = database.listFavourites(session.userId)
		if( favs.length > 0 ){
			def render = database.loadRender(renderId)
			if( favs.any{ it.CMPath == render.CMPath; }) meta += "<meta content=\"true\" name=\"${HtmlGrammar.META_ISFAVOURITE}\"/>"
		}
		def i = html.indexOf("<meta")
		html = html.substring( 0, i ) + meta + html.substring(i)
		println html.substring(0, 300);
		
		logger.logActivity(session.userId,IHistoryLogger.VIEW_REPORT,renderId,"");
		return SCResponse.fromHtml(html);
		
	case ~/images\/\d+/:
		def blobId = Integer.valueOf(args["blobId"])
		return SCResponse.fromBytes(database.getBlob(renderId, blobId, VM.getBlobFormatFromFormat(fmt), -1, -1), mimetype);
	case ~/session\/(.*?)/:
		if( fmt != "json" ) return null
		session.sanityCheck();
		def writer = new StringWriter()
		def xml = new MarkupBuilder(writer)
		xml.render(id:renderId)
		return writer.toString()
}
return null