// $Author$
// $DateTime$
// $File$
// $Revision$
//
// Copyright 2005-2006 Cognos, Inc.
package processors

import java.text.SimpleDateFormat;
import com.cognos.mobile.common.CMErrors;
import com.cognos.mobile.common.CMException;
import com.cognos.mobile.server.core.SCResponse;
import com.cognos.mobile.common.C8;
import com.cognos.mobile.common.CMStringHelper2
import com.cognos.mobile.common.CMUrlConstants;
import com.cognos.mobile.common.IInputStreamFactory;
import com.cognos.mobile.common.IPersistenceStore;
import com.cognos.mobile.common.TempStoreHelper;
import com.cognos.mobile.common.BuxPromptHelper;
import com.cognos.mobile.drill.DrillContextAndTarget;
import com.cognos.mobile.xml.XML;
import com.cognos.mobile.database.IMobileDatabase;
import com.cognos.mobile.compiler.ReportCompiler;
import com.cognos.mobile.server.c8.C8CCSReportRunner;
import com.cognos.mobile.server.handler.SLHelper;
import com.cognos.mobile.server.run.RUNRunReport;
import com.cognos.mobile.server.run.RUNDrillThroughReport;
import com.cognos.mobile.server.bus.CCSService;
import com.cognos.mobile.server.bus.IC8Configuration;
import com.cognos.mobile.server.core.ReportRunner;
import com.cognos.mobile.server.core.ReportRenderer;
import com.cognos.mobile.server.core.SCConfiguration;
import com.cognos.mobile.server.core.SCRequest;
import com.cognos.mobile.server.core.SCResponse;
import com.cognos.mobile.server.core.SCUserSession;
import com.cognos.mobile.server.bus.CCSService;
import com.cognos.mobile.standardedition.DOM4JUtil;
import com.cognos.mobile.task.ThreadPool;
import com.cognos.mobile.vm.VM;
import com.cognos.mobile.xml.XMLHelper;
import com.cognos.mobile.c8.C8Connection;
import com.cognos.mobile.c8.IReportRunner;

import com.cognos.mobile.generator.html.HtmlElementFactory
import com.cognos.mobile.generator.ldx.LdxReport
import com.cognos.mobile.generator.html.HtmlGenerator
import com.cognos.mobile.generator.vm.VmElementFactory
import com.cognos.mobile.server.handler.IPromptFiller;


import groovy.xml.MarkupBuilder;

def dbg = { msg -> VM.log(this.class, VM.SEVERITY_DEBUG, msg); }
def err = { msg -> VM.log(this.class, VM.SEVERITY_ERROR, msg); }


def renderDetails = { session, database, storeId ->
	def writer = new StringWriter()
	def xml = new MarkupBuilder(writer)
	def label = database.getReportLabel(storeId)
	xml.details(userId:"$session.userId", label:"$label", storeId:"$storeId") {
		reportRecentRenders {
			database.getReportRecentRenders(session.userId, storeId).each{ rr -> render( status: rr.status, renderTime: CMStringHelper2.formatDateTime(rr.renderTime), id: rr.renderID, img: "/mobileService/renders/${rr.renderID}/pages/1/thumb.png")}
		}
		reportSavedRenders {
			database.getReportSavedRenders(session.userId, storeId).each{ rr -> render( status: rr.status, renderTime: CMStringHelper2.formatDateTime(rr.renderTime), id: rr.renderID, img: "/mobileService/renders/${rr.renderID}/pages/1/thumb.png", savedName: rr.savedName)}
		}
	}
	return writer.toString()
}

def searchAndSelectKey = { it ->
	if (it.key.equals("srchval")||it.key.equals("pname")||it.key.equals("swsID")||it.key.equals("mtchAny")||it.key.equals("mtchAll")||it.key.equals("nocase"))
		return true;
	else return false;
}
def matcher = (path =~ /\/report\/(\d+)?\/?(.*)$/)
subpath = matcher[0][2]

def userId = session.userId
def format = args["format"];
def sourcePath = null
def reportPath = null
def storeId = null

def p = args["storeId"]
if( p == null ){
	matcher = ( path =~ /\/report\/(.+)$/)
	p = matcher[0][1]
}
if( p.startsWith("storeID(")) storeId = p.substring( 9, p.length() -  2)
else if( p.startsWith("store:" )) storeId = p.substring( 6, p.length())
else if( p.startsWith("source:" )) sourcePath = p.substring( 7, p.length())
else if( p.startsWith("cm:" )) reportPath = p.substring( 3, p.length())

switch(subpath) {
	case ~/details\/(.*?)/:
		return renderDetails(session, database, storeId);
		break

	/**
	 * - find the item in cm
	 * - look for any existing p_* parameters that have been submitted
	 */
	case ~/ccs\/(.*?)/:
		def ctxID = args["ctxID"]
	   	if( p.startsWith("ctxID:")) ctxID = p.substring( 6, p.length())
	   	def widgetID = args["wid"]
		def widgetStoreID = args["bid"];
		def tmpID = args["tid"]
 		if( p.startsWith("wid:")){
 			matcher = ( p =~ /wid:(.+)\|store:(.+)\|tid:(.+)$/)
 			widgetID = matcher[0][1]
 			storeId = matcher[0][2]
 			tmpID = matcher[0][3]
 			dbg "ccs widget index:"+widgetID+" storeId:"+storeId+" tmpID:"+tmpID
 		}
		if ( ctxID != null){
			context = TempStoreHelper.readString(tmp,ctxID,false);
			drillContext = RUNDrillThroughReport.parseDrillContextXML(context);
			item = session.c8PortalTree.findItem(null, drillContext.getTarget().getCMPath(), null);
			storeId = item.storeID;
		}
		
		def widgetItemDefaultName = "";
		if(widgetStoreID != null)
		{
			def widgetPortalItem =session.c8PortalTree.findItem(widgetStoreID, null, null);
			if(widgetPortalItem != null)
			{
				widgetItemDefaultName = widgetPortalItem.defaultName;
			}
		}
		def item = session.c8PortalTree.findItem(storeId, reportPath, sourcePath)
		def ccs = new CCSService(request.cookies.hash, c8config.c8DispatcherUrl+ "/rds", isf)
		def prompt = ccs.askCCSDirectlyForAnElement("/" + args["ccspath"], args.findAll{ it.key.startsWith("p_")||searchAndSelectKey(it)})
	
		if( prompt.hasMixedContent()&& prompt.namespace.URI.contains( "layoutData" )){
			// Parse LDX
			
			def report = new LdxReport(0, null, c8config.c8GatewayUrl, c8config.c8DispatcherUrl, item.storeID, item.cmPath, 1, new VmElementFactory(), new HtmlElementFactory(), "", 0, item.defaultDescription, null);
			def out = DOM4JUtil.prettyPrint(prompt)
			def reportIS = new ByteArrayInputStream(out.getBytes("UTF-8"))
			report.processReportOutput(0, reportIS)			
			// Make an HTML dom of the LDX
			try{
				def generator = new HtmlGenerator(gte,true,null,null)
				def baos = new ByteArrayOutputStream()
				generator.generate(report, new PrintStream( baos, false, "UTF-8"))
				baos.close();
				dbg("Generated HTML: \n" + baos.toString("UTF-8"))
				def ldx = DOM4JUtil.readDocumentFromXHTML(baos.toString("UTF-8"))
			
				def head = ldx.selectSingleNode("//head")
				// a little clue to the client that this is a prompt...
				head.add( DOM4JUtil.createElement("meta", ["name": "ReportType", "content": "prompt"]))
				def body = ldx.selectSingleNode("//body")
				// insert a form object for prompt submission
				// ccs redirects us so we can use a session object
				// Note: we need to know about the session url for further communication; I have inserted this url as
				// the attribute "source"
				def action
				if (ctxID != null) action = prompt.attribute("source").value.replaceFirst(".*?/rds/", "/mobileService/report/ccs/ctxID:" + ctxID + "/" );
				else if (widgetID != null) action = prompt.attribute("source").value.replaceFirst(".*?/rds/", "/mobileService/report/ccs/wid:" + widgetID + "|store:"+storeId+"|tid:"+tmpID+"/" );
				else action = prompt.attribute("source").value.replaceFirst(".*?/rds/", "/mobileService/report/ccs/store:" + storeId + "/" );
				
				def form = DOM4JUtil.createElement("form", ["dfName":widgetItemDefaultName,"id": "prompts", "action": action, "method": "post", "conversationId": action.substring(action.indexOf("/conversationID/") + 16)])
				body.elements().each{
					it.detach()
					form.add(it);
				}
				body.add(form)
				return SCResponse.fromHtml(DOM4JUtil.prettyPrintAsXHTML(ldx.rootElement).getBytes("UTF-8"))
			} catch( Exception e ){
				err e
			}
		} else { 
			// assume we have promptAnswers
			// redirect back to try running a report, only this time append the ccs session
			if (ctxID == null){
				dbg "BACK TO RUNNING REPORT!"
				if (widgetID != null) {
					dbg "back to running report " + "${request.environmentVars.SCRIPT_NAME}/mobileService/report/store:${storeId}.json?wid="+widgetID+"&tid="+tmpID+"&ccs=/" + args["ccspath"].replace("/forward", "")
					return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/store:${storeId}.json?wid="+widgetID+"&tid="+tmpID+"&ccs=/" + args["ccspath"].replace("/forward", ""), null)
				}
				return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/store:${storeId}.json?ccs=/" + args["ccspath"].replace("/forward", ""), null)
			}
			dbg "BACK TO drill through RUNNING REPORT"
			return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/drillthrough/1.json?ctxID="+ctxID+"&ccs=/" + args["ccspath"].replace("/forward", ""), null)
		}
		break;
	case ~/drillthrough\/(.*?)/:
		def context =  args["mob_ctx"]
		def checking = args["mob_chk"]
		def outputFormat = args["mob_fmt"]
		def ccsSession = args["ccs"]
		if (context == null){
			ctxID = args["ctxID"];
			dbg "ctxID:"+ctxID
			if (ctxID != null) context = TempStoreHelper.readString(tmp,ctxID,true);
			dbg "context:"+context
		}
		if (context == null) throw new CMException(CMErrors.GENERIC, "drill through context is null")
		if ( outputFormat != null && !outputFormat.equals("xml") ) context = URLDecoder.decode(context, "UTF-8");
		def drillContext = null;
		def item = null;
		drillContext = RUNDrillThroughReport.parseDrillContextXML(context);
		item = session.c8PortalTree.findItem(null, drillContext.getTarget().getCMPath(), null);
		if ( outputFormat != null && (outputFormat.equals("json") && checking.equals("true"))){
			def rr = database.getLatestDrillTargetRender(session.getUserId(), item.storeID, drillContext.generateParmasString());
			def writer = new StringWriter()
			def xml = new MarkupBuilder(writer)
			if( rr != null ){
				def label = rr.label
				xml.render(status: rr.status, renderTime:  CMStringHelper2.formatDateTime(rr.renderTime), id: rr.renderID, img: "/mobileService/renders/${rr.renderID}/pages/1/thumb.png")
				return writer.toString()
			} else {
				xml.render(id:0)
				return writer.toString()
			}
		} else {
			def ccs = new CCSService(request.cookies.hash, c8config.c8DispatcherUrl+ "/rds", isf, true);
			def promptAnswers = null
			def query = null
			if (ccsSession == null){
				if (drillContext != null ) {
					promptAnswers = drillContext.toPromptAnswer();
					query = drillContext.toQueryString();
				}
			} else {
				dbg "drillthrough call back:"
				def hasPrompts = ccs.askCCSDirectlyForAnElement("/reportPrompts/report/" + item.storeID, null).hasMixedContent()
				if( hasPrompts){
					def prompts = ccs.askCCSDirectly(ccsSession.replace("/forward", ""), null)
					promptAnswers = DOM4JUtil.prettyPrint(prompts)
					dbg "drillthrough GOT PROMPTS: $promptAnswers"
				}
			}
			C8Connection c8Connection = C8Connection.fromBiBusEnvelope(c8config.getC8DispatcherUrl(), request.createRequestCopy());
			// create the runnable
			runnable = new RUNDrillThroughReport(outputFormat, database, request.getCookies().getHash(), session, c8Connection, context, isf, c8config, tmp, scconfig, promptAnswers);
			runnable.run();
			if (runnable.getException() != null) {
				if (runnable.getException().getMessage().indexOf("RDS-ERR-1021") != -1) {
					/**
					 * This is for RDS-ERR-1021 "The IBM Cognos 8 report could not be run because 
					 * it contains unanswered prompts. Please provide the prompt answers, 
					 * and run the report
					 */
					tmpPath = tmp.createTempPath("ctx", "", "",true);
					TempStoreHelper.saveString(tmp,tmpPath,context);
					return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/ccs/store:${item.storeID}/reportPrompts/report/${item.storeID}.html?ctxID=${tmpPath}&${query}", null)
				} else {
					throw runnable.getException();
				}
			} else {
				def rr = runnable.render;
				def writer = new StringWriter()
				def xml = new MarkupBuilder(writer)
				if ( rr != null ){
					def label = rr.label
					xml.render(status: rr.status, renderTime:  CMStringHelper2.formatDateTime(rr.renderTime), id: rr.renderID, img: "/mobileService/renders/${rr.renderID}/pages/1/thumb.png")
					return writer.toString()
				} else {
					xml.render(id:0)
					return writer.toString()
				}
			}
		}
		break;
	/**
	 * Here's how this rolls:
	 * - get the item from cm
	 * - ask ccs for prompts, check if the returned doc is LDX
	 * - if we have LDX, check for the existence of a ccs session
	 *   - if ccssession exists, we should already have prompts:
	 *     - get the promptAnswers doc from ccs, use this for running the report
	 *   - if it doesn't exist, we should act as a proxy to ccs (see report/ccs handler above) until we do have prompts
	 */
	default:
		def item = session.c8PortalTree.findItem(storeId, reportPath, sourcePath)
		def fmt = args["format"]?: json
		def ccsSession = args["ccs"]
	 	def ccs = new CCSService(request.cookies.hash, c8config.c8DispatcherUrl+ "/rds", isf);
		def promptAnswers = null
		
		//If "Prompt for values" flag is not set, try to run it directly.
		//If it fails, we will try to follow its regular procedure.
		if (!item.prompt){
			C8Connection c8Connection = C8Connection.fromBiBusEnvelope(c8config.getC8DispatcherUrl(), request.createRequestCopy());
			C8CCSReportRunner reportRunnerService = new C8CCSReportRunner(ReportCompiler.INPUTTYPE_LDX_PAGED, ccs, promptAnswers, c8Connection, tmp, (DrillContextAndTarget)null)
			RUNRunReport runnable = new RUNRunReport(reportRunnerService, "html", database, session, c8Connection, ccs, item, (String)null, isf, c8config, tmp, scconfig, (String)promptAnswers, request.cookies.passport)
			runnable.run();
			if (runnable.getException() == null ) {
				def rr = runnable.render
				def writer = new StringWriter()
				def xml = new MarkupBuilder(writer)
				def label = rr.label
				xml.render(status: rr.status, renderTime: CMStringHelper2.formatDateTime(rr.renderTime), id: rr.renderID, img: "/mobileService/renders/${rr.renderID}/pages/1/thumb.png")
				return writer.toString()
			}
		}
		def buxPrompts = new ArrayList();
		try{
			result = ccs.askCCSDirectlyForAnElement("/reportPrompts/report/" + item.storeID, null);
			def hasPrompts = result.hasMixedContent()
			buxPrompts = BuxPromptHelper.getStoreIDs(result);
		
			if( hasPrompts ){
				def promptFiller = controller.getLocationPromptFiller();
				if ( promptFiller != null) {
					def promptsEl = ccs.describePrompts(item, null, false);
					IPromptFiller.FillPromptsResponse fpr = promptFiller.fillPrompts(request, promptsEl, promptAnswers);
					if (fpr.forcedResponseStatus != null) return SCResponse.fromXml(fpr.forcedResponseStatus, ""); 
					promptAnswers = fpr.promptAnswers;
					promptsEl = fpr.prompts;
					dbg "prompt filler GOT PROMPTS: $promptAnswers"
				}
				
				if (promptAnswers == null){
					if( ccsSession == null ) {
						return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/ccs/store:${item.storeID}/reportPrompts/report/${item.storeID}.html", null)
					}
					def prompts = ccs.askCCSDirectly(ccsSession.replace("/forward", ""), null)
					promptAnswers = DOM4JUtil.prettyPrint(prompts)
				}
			} else if (buxPrompts.size() > 0 ){
				def buxWidgetID = args["wid"]
				def curWidgetIdx = (buxWidgetID != null)?Integer.parseInt(buxWidgetID):0;
				def buxStoreID = (String) buxPrompts.get(curWidgetIdx);
			
				if( buxWidgetID == null ) {
					tmpPath = tmp.createTempPath("bux", "", "",true);
					if (buxStoreID != null ) return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/ccs/store:${item.storeID}/reportPrompts/report/${buxStoreID}.html?wid=${curWidgetIdx}&tid=${tmpPath}&bid=${buxStoreID}", null)
				} else {
					tmpPath = args["tid"];
					def prompts = ccs.askCCSDirectly(ccsSession.replace("/forward", ""), null)
					promptAnswers = DOM4JUtil.prettyPrint(prompts)
					TempStoreHelper.saveString(tmp,tmpPath+"_"+curWidgetIdx,promptAnswers);
					curWidgetIdx += 1;
					if (curWidgetIdx < buxPrompts.size()){
						//do next prompt;
						buxStoreID = (String) buxPrompts.get(curWidgetIdx);
						if (buxStoreID != null) return SCResponse.fromRedirect("${request.environmentVars.SCRIPT_NAME}/mobileService/report/ccs/store:${item.storeID}/reportPrompts/report/${buxStoreID}.html?wid=${curWidgetIdx}&tid=${tmpPath}&bid=${buxStoreID}", null)
					}
					//we are done, so try to run the rpeort;
					}	
				}
			}catch(IOException e){
				err "Couldn't chat with RDS." + e;
		}
		
		C8Connection c8Connection = C8Connection.fromBiBusEnvelope(c8config.getC8DispatcherUrl(), request.createRequestCopy());
		C8CCSReportRunner reportRunnerService = new C8CCSReportRunner(ReportCompiler.INPUTTYPE_LDX_PAGED, ccs, promptAnswers, c8Connection, tmp, (DrillContextAndTarget)null)
		RUNRunReport runnable = new RUNRunReport(reportRunnerService, "html", database, session, c8Connection, ccs, item, (String)null, isf, c8config, tmp, scconfig, (String)promptAnswers, request.cookies.passport)
		if (buxPrompts.size() > 0){
			tmpPath = args["tid"];
			renderID = runnable.getRender().getRenderID();
			for (int i = 0; i < buxPrompts.size(); i++){
				buxStoreID = (String) buxPrompts.get(i);
				answer = TempStoreHelper.readString(tmp,tmpPath+"_"+i,true);
				//now we have the render ID, so we can store the prompt answers in a thread safe name and without passing the parameters;  
				if (answer != null) TempStoreHelper.saveString(tmp,BuxPromptHelper.getPromptAnswersStoreName(renderID,i,buxStoreID),answer);
			}
		}
		threadpool.execute(runnable);
		
//		dbg("FORMAT: " + format)
//		def result = "<${XML.XML_RENDER}><${XML.XML_RENDERID}>${runnable.getRender().getRenderID()}</${XML.XML_RENDERID}></${XML.XML_RENDER}>" 
//		dbg("RENDERING: " + result)
//		return result

		if (runnable.getException() != null) throw runnable.getException();
		def rr = runnable.render
		def writer = new StringWriter()
		def xml = new MarkupBuilder(writer)
		def label = rr.label
		xml.render(status: rr.status, renderTime: CMStringHelper2.formatDateTime(rr.renderTime), id: rr.renderID, img: "/mobileService/renders/${rr.renderID}/pages/1/thumb.png")
		return writer.toString()
}
