// Licensed Materials - Property of IBM
// BI and PM: Mobile
// (C) Copyright IBM Corp. 2007, 2011
// US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
console.log('loading shared_en.xml');
var i18n = {"GENERIC": "An unexpected error occurred.",
"UNSUPPORTED_FEATURE": "This feature is not supported.",
"UNSUPPORTED_ENCODING": "Does not support the character encoding %string%.",
"STACK": "An internal error occurred.",
"FILE_READ": "Unable to read the %string% file.",
"URL_READ": "Unable to read the URL %string%.",
"MALFORMED_URL": "The URL %string% is invalid.",
"TRANSFORM_FAILURE": "An XML transform failed.",
"PARSER_CONFIGURATION": "A problem occurred with the configuration of the XML parser.",
"SAX": "A SAX parsing problem occurred.",
"INVALID_URL_SCHEME": "Only HTTP and HTTPS URLs are supported.",
"TASK_EXCEPTION": "An error occurred during a background operation.",
"UNKNOWN_ERROR_CODE": "No message is available for the error code %integer%.",
"VALIDATE_OUT_OF_RANGE": "The value for the field '%string%' must be in the range '%string%' to '%string%'.",
"VALIDATE_NUMERIC_ONLY": "The value for the field '%string%' must be numeric only.",
"VALIDATE_AFTER_ONLY": "The value for the field '%string%' must be after '%string%'",
"VALIDATE_BEFORE_ONLY": "The value for the field '%string%' must be before '%string%'",
"VALIDATE_REQUIRED": "You must provide a value for the mandatory field '%string%'.",
"VALIDATE_INVALID_SELECTION": "The value '%string%' for the field '%string%' is not in the list of acceptable values.",
"VALIDATE_ERROR_FILLING_PROMPTS": "Unable to automatically fill prompts.",
"VALIDATE_TO_LOW": "The value for the field '%string%' must be greater than '%string%'",
"VALIDATE_TO_HIGH": "The value for the field '%string%' must be less than '%string%'",
"VALIDATE_EARLIEST_ACCEPTABLE": "The earliest acceptable value is '%string%'.",
"VALIDATE_LATEST_ACCEPTABLE": "The latest acceptable value is '%string%'.",
"VALIDATE_PROMPTS_INVALID": "Your report cannot be run until you correct the following prompt fields: '%string%'.",
"VALIDATE_UNSUPPORTED_MANDATORY_PLURAL": "The report %string% contains unsupported mandatory prompts: %string%.  Please save prompt values in the Cognos Connection portal, and rerun.",
"VALIDATE_UNSUPPORTED_OPTIONAL_PLURAL": "The report %string% contains unsupported optional prompts: %string%.  The report should still run, but you will not be able to modify these prompts.",
"VALIDATE_UNSUPPORTED_MANDATORY_SINGULAR": "The report %string% contains an unsupported mandatory prompt: %string%.  Please save the prompt value in the Cognos Connection portal, and rerun.",
"VALIDATE_UNSUPPORTED_OPTIONAL_SINGULAR": "The report %string% contains an unsupported optional prompt: %string%.  The report should still run, but you will not be able to modify the prompt value.",
"VALIDATE_ILLEGAL_ARGUMENT": "Illegal argument for the field '%string%'.",
"VALIDATE_UNSUPPORTED_OPTIONAL": "The prompt type for the field %string% is unsupported.  The report should still run, but you will not be able to modify the prompt value.",
"VALIDATE_UNSUPPORTED_MANDATORY": "The prompt type for the field %string% is unsupported.  Please save prompt values in the Cognos Connection portal, and rerun.",
"VALIDATE_FIX_PROMPTS": "Please fix prompts with errors before submitting.",
"AUTHENTICATE_TITLE": "Sign-in",
"LOGON_ENTER_NETWORK_CREDENTIALS": "Please enter your network credentials for '%string%'.",
"LOGON_ENTER_NETWORK_CREDENTIALS_2": "Please enter your network credentials.",
"LOGON_DOMAIN": "Domain:",
"LOGON_USERNAME": "Username:",
"LOGON_PASSWORD": "Password:",
"WELCOME": "Welcome to %string%! Choose 'Log On' to start.",
"INBOX_USER_DEMO": "demo",
"RECENTLY_RUN_REPORTS": "Recently run reports",
"WELCOME_SECTION": "Welcome",
"FAVOURITES": "Favorites",
"PROGRESS_PLEASE_WAIT": "Please wait...",
"DOWNLOAD_REPORT_1": "Waiting for report...",
"DOWNLOAD_REPORT_2": "Please wait, or close to view the report later.",
"DOWNLOAD_REPORT_BUTTON": "Close",
"BROWSE_PORTAL_1": "Browsing portal...",
"BROWSE_PORTAL_2": "Please wait, or click to cancel.",
"BROWSE_PORTAL_BUTTON": "Cancel",
"COMPILE_REPORT_1": "Checking for prompts...",
"COMPILE_REPORT_2": "Please wait, or click to cancel.",
"COMPILE_REPORT_BUTTON": "Cancel",
"DELETE_RENDER_1": "Deleting report...",
"DELETE_RENDER_2": "Please wait for confirmation, or click to return to your previous task.",
"DELETE_RENDER_BUTTON": "Cancel",
"DOWNLOADING_INBOX_1": "Downloading inbox...",
"DOWNLOADING_1": "Downloading...",
"DOWNLOADING_2": "Please wait, or click to cancel.",
"DOWNLOADING_BUTTON": "Cancel",
"DRILL_THROUGH_1": "Performing drill-through...",
"DRILL_THROUGH_2": "Please wait, or click to cancel.",
"DRILL_THROUGH_BUTTON": "Cancel",
"DRILL_UP_1": "Performing drill-up...",
"DRILL_UP_2": "Please wait, or click to cancel.",
"DRILL_UP_BUTTON": "Cancel",
"DRILL_DOWN_1": "Performing drill-down...",
"DRILL_DOWN_2": "Please wait, or click to cancel.",
"DRILL_DOWN_BUTTON": "Cancel",
"LOGON_1": "Logging on...",
"LOGON_2": "Please wait, or click to cancel.",
"LOGON_BUTTON": "Cancel",
"OPEN_1": "Opening report...",
"OPEN_2": "Please wait, or close to view the report later.",
"OPEN_BUTTON": "Cancel",
"SEARCH_1": "Searching...",
"SEARCH_2": "Please wait, or click to cancel.",
"SEARCH_BUTTON": "Cancel",
"ZOOM_SCENE_1": "Zooming...",
"ZOOM_SCENE_2": "Please wait, or click to cancel.",
"ZOOM_SCENE_BUTTON": "Cancel",
"ZOOMING_SCENE": "Zooming scene...",
"CANCEL": "Cancel",
"LOADED_RENDER": "Report downloaded",
"RUN_REPORT_DONE": "The report '%string%' is now available in your inbox.",
"RUN_REPORT_QUEUED": "The report is now running on the server and will be delivered to your inbox when done.",
"BUILDING_SCENE": "Building Scene...",
"HISTORY_LOG_IN": "Logged in",
"HISTORY_VIEW_REPORT": "Viewed report: '%string%'",
"HISTORY_SCHEDULED_REPORT_START": "Started to run a scheduled report: '%string%' ",
"HISTORY_SCHEDULED_REPORT_FINISH": "finish running a scheduled report: '%string%'",
"HISTORY_REPORT_START": "Started to run an ad-hoc report: '%string%'",
"HISTORY_REPORT_FINISH": "Finished running an ad-hoc report: '%string%'",
"HISTORY_DOWNLOAD_REPORT": "Downloaded report: '%string%'",
"SERVER_BAD_REPORT_PATH": "The report path %string% is invalid. The report could have been moved or deleted.",
"SERVER_CONNECT_TO_COGNOS_SERVER_FAILED": "Unable to connect to the %string% server.",
"SERVER_LOGIN_FAILED": "Unable to log on to the %string% server.",
"SERVER_LOGOFF_FAILED": "Unable to log off from the %string% server.",
"SERVER_QUERY_FAILED": "A query against the %string% content store failed.",
"SERVER_RESPONSE_PARSE_ERROR": "Unable to understand the response from the %string% server.",
"SERVER_INVALID_IMAGE_TYPE": "Encountered an invalid image. The image cannot be displayed.",
"SERVER_DOWNLOAD_FAILED": "Unable to download an item.",
"SERVER_BAD_CONTENT_TYPE": "Returned an unsupported content type %integer%.",
"SERVER_RUN_REPORT_FAILED": "Unable to run the report.",
"SERVER_AUTHENTICATION_FAILED": "Unable to authenticate the user.",
"SERVER_PROMPT_ERROR": "The report contains prompts. Prompts are not supported. The report cannot be accessed through %string%.",
"SERVER_SERVICE_FAILED": "The %string% service failed.",
"SERVER_IMAGE_DOWNLOAD_FAILED": "Unable to download an image.",
"SERVER_BLOB_DECODE_FAILED": "Unable to read a portion of the report. The report may not appear correctly.",
"SERVER_CODE_DECODE_FAILED": "Unable to read a report code record. The report may not appear correctly.",
"SERVER_STRING_DECODE_FAILED": "Unable to decode a report string.",
"SERVER_DATABASE_DRIVER_FAILED": "The database driver failed.",
"SERVER_DATABASE_QUERY_FAILED": "A database query failed.",
"SERVER_DATABASE_UPDATE_FAILED": "Unable to write to the database.",
"SERVER_FAILED_TO_GENERATE_RENDER_ID": "Unable to generate a new ID for the report.",
"SERVER_RENDER_INSERT_FAILED": "Encountered a problem while writing a report to the database.",
"SERVER_DATABASE_STRING_READ_FAILED": "Encountered a problem while reading a report from the database.",
"SERVER_DATABASE_PREPARE_STATEMENT_FAILED": "Encountered a problem with the database.",
"SERVER_DATABASE_INSERT_BLOB_FAILED": "Encountered a problem while writing a report to the database.",
"SERVER_DATABASE_BLOB_READ_FAILED": "Encountered a problem while reading a report from the database.",
"SERVER_DATABASE_RENDER_READ_FAILED": "Encountered a problem while reading a report from the database.",
"SERVER_DATABASE_CODE_READ_FAILED": "Encountered a problem while reading a report from the database.",
"SERVER_BAD_ADDRESS": "Part of the report is corrupt. The report may not appear correctly.",
"SERVER_NODE_NOT_FOUND": "Unable to find the report node %string%.",
"SERVER_NODE_IMAGE_NOT_FOUND": "Unable to find an image for the node %string%. ",
"SERVER_IMAGE_SAVE_FAILED": "Unable to save an image.",
"SERVER_READ_FILE_FAILED": "Unable read a file.",
"SERVER_RESPONSE_WRITE_FAILED": "Unable to write a response.",
"SERVER_BAD_RENDERID": "The report ID %integer% that was specified is invalid.",
"SERVER_BAD_PARAMETER": "A parameter that was specified is invalid.",
"SERVER_BUILD_CACHE_IO_ERROR": "Encountered an input/output error while building the cache.",
"SERVER_USER_NOT_FOUND": "Unable to find the user.",
"SERVER_FAILED_TO_GENERATE_USER_ID": "Unable to generate a new user ID.",
"SERVER_USER_ADD_FAILED": "Unable to add a user.",
"SERVER_MISSING_CREDENTIAL": "Unable to authenticate with the %string% server. The credential '%string%' is missing.",
"SERVER_SCHEDULE_DATABASE_READ_FAILED": " Encountered a problem  while reading a schedule from the database..",
"SERVER_SCHEDULE_DATABASE_WRITE_FAILED": " Encountered a problem  while writing a schedule to the database..",
"SERVER_DPR_ERR_2022": "(DPR-ERR-2022) The %string% service is not configured properly or is missing.",
"SERVER_DATABASE_CONFIGURATION": "Encountered a database configuration error.",
"SERVER_DATABASE_CONNECTION_POOL_INTERNAL": "Encountered a problem with the connection to the database.",
"SERVER_DATABASE_SCHEMA_UPGRADE_FAILED": "The database schema upgrade failed.",
"SERVER_CREDENTIAL_PATH_FAILED": "Encountered a problem with the user's credentials.",
"SERVER_READ_CONFIGURATION_FAILED": "Encountered an error while reading the settings file.",
"SERVER_DPR_ERR_2058": "The server has not finished initializing.",
"SERVER_SERVER_ERROR": "The server returned the error %string% .",
"SERVER_DATABASE_DISPOSED": "Unable to access the database.",
"SERVER_BAD_HTTP_RESPONSE_CODE": "The server returned the HTTP error response code %string%.",
"SERVER_INVALID_RESPONSE": "The server returned an invalid response.",
"SERVER_UNSUPPORTED_AUTHENTICATION": "The server requested the security protocol '%string%'. This protocol is not supported.",
"SERVER_NOT_AVAILABLE": "The %string% gateway is unable to connect to the %string% BI server. The server may be unavailable or the gateway may not be configured correctly.",
"SERVER_INTERNAL": "Encountered an internal error.",
"SERVER_COMM_ERROR": "Encountered an error while communicating with the server.",
"SERVER_BUS_OPERATION_FAILED": "Encountered an error while communicating with another component of %string%.",
"SERVER_403": "(HTTP error 403 (Forbidden)) The resource is not available or the server is too busy.",
"SERVER_413": "(HTTP error 413 (Too Large)) The server was not configured correctly.",
"SERVER_RENDER_NOT_FOUND": "The report you requested is not available on the server.  Please contact your administrator.",
"SERVER_DATABASE_VERSION_NOT_SUPPORTED": "The database was created by a version of this product that is more recent than the version that is currently running. This version cannot use the database. Please upgrade to the later version.",
"SERVER_DPR_ERR_2014": "(DPR-ERR-2014) The dispatcher cannot find an instance of the %string% service to load balance the request to.",
"SERVER_SCHEDULE_NOT_SUPPORTED": "Scheduling a report from the client is no longer supported. Please upgrade your client to the latest version.",
"SERVER_RUN_SCHEDULED_REPORT_FAILED": "An unexpected error occurred when processing a scheduled report.",
"SERVER_404": "(HTTP error 404 (Not Found)) File or Directory not found.",
"SERVER_400": "(HTTP error 400 (Bad Request)) The request could not be understood by the server due to malformed syntax.",
"VM_BAD_PARAMETER": "A parameter was specified that is invalid.",
"VM_BAD_INSTRUCTION": "An instruction was found that is invalid.",
"VM_BAD_PROGRAM": "The report is corrupt and may not appear correctly.",
"VM_ASSEMBLER_PROGRAM_NOT_FOUND": "A problem occurred while generating the report.",
"VM_ASSEMBLER_OUTPUT_FILE_WRITE_FAILED": "A problem with a temporary file occurred while generating the report.",
"VM_CCS_RESULT": "The CCS component returned an error.",
"VM_BAD_SEQUENCE": "The report is corrupt and may not appear correctly.",
"VM_DEMO_LOAD_FAILED": "Unable to load the demonstration inbox.",
"VM_OPTIONS_ERROR": "Unable to read or write options.",
"APP_EVENT": "%string%",
"MENU_ABOUT": "About",
"MENU_BACK": "Back",
"MENU_CLOSE": "Close",
"MENU_CANCEL": "Cancel",
"MENU_OK": "Ok",
"MENU_YES": "Yes",
"MENU_NO": "No",
"MENU_REPORTS_ONLY": "Reports only",
"MENU_REPORT_ONLY": "Report only",
"MENU_DELETE": "Delete",
"MENU_DELETE_ALL": "Delete All",
"MENU_OPEN_DEMO_INBOX": "Open Demo Inbox",
"MENU_REFRESH_INBOX": "Refresh Inbox",
"MENU_REFRESH": "Refresh",
"MENU_HELP": "Help",
"MENU_MARK_READ": "Mark As Read",
"MENU_MARK_ALL_READ": "Mark All As Read",
"MENU_MARK_UNREAD": "Mark As Unread",
"MENU_NEXT_COLUMN": "Next Column",
"MENU_NEXT_ROW": "Next Row",
"MENU_OPEN": "Open",
"MENU_FOCUS_OBJECT": "Focus",
"MENU_FOCUS_HEADER": "Header Focus",
"MENU_FOCUS_FOOTER": "Footer Focus",
"MENU_FOCUS_TABLE": "Table Focus",
"MENU_FOCUS_CHART": "Chart Focus",
"MENU_FOCUS_TEXT": "Text Focus",
"MENU_FOCUS_IMAGE": "Image Focus",
"MENU_FOCUS_COLUMN": "Column Focus",
"MENU_FOCUS_ROW": "Row Focus",
"MENU_DRILL_THROUGH": "Drill Through...",
"MENU_DRILL_UP": "Drill Up...",
"MENU_DRILL_DOWN": "Drill Down...",
"MENU_OPTIONS": "Options",
"MENU_PAGE": "Page",
"MENU_PAGE_GOTO": "Page...",
"MENU_PAGE_PREV": "Previous",
"MENU_PAGE_NEXT": "Next",
"MENU_TABLE": "Table",
"MENU_PREV_ROW": "Previous Row",
"MENU_PREV_COLUMN": "Previous Column",
"MENU_BROWSE": "Browse",
"MENU_BROWSE_FILESYSTEM": "Browse Files",
"MENU_SWITCH_TO_COLUMN_FOCUS": "Switch to Column Focus",
"MENU_SWITCH_TO_ROW_FOCUS": "Switch to Row Focus",
"MENU_ZOOM": "Zoom",
"MENU_ZOOM_IN": "Zoom In",
"MENU_ZOOM_OUT": "Zoom Out",
"MENU_ZOOM_GOTO": "Zoom...",
"MENU_ZOOM_FIT_WIDTH": "Fit to Width",
"MENU_ZOOM_FIT_PAGE": "Fit to Page",
"MENU_FIND": "Find in Page",
"MENU_FINDNEXT": "Find Next in Page",
"MENU_SEARCH": "Search...",
"MENU_LOG_ON": "Log On",
"MENU_LOG_ON_ANONYMOUS": "Anonymous",
"MENU_LOG_OFF": "Log Off",
"MENU_SEND": "Send",
"MENU_MARK_CELL": "Mark Cell",
"MENU_UNMARK_CELL": "Unmark Cell",
"MENU_EXIT": "Exit",
"MENU_RUN_REPORT": "Run Report",
"MENU_ERROR_DETAILS": "Error Details",
"MENU_SAVE": "Save",
"MENU_MENU": "Menu",
"MENU_TOOLS": "Tools",
"MENU_REPORT": "Report",
"MENU_LOOKUP": "Lookup...",
"MENU_CALL": "Call...",
"MENU_MAILTO": "Mailto...",
"MENU_SET_WELCOME": "Add to Welcome page",
"MENU_REMOVE_WELCOME": "Remove from Welcome page",
"MENU_SET_FAVOURITE": "Set as Favorite",
"MENU_REMOVE_FAVOURITE": "Remove Favorite",
"INBOX_TITLE": "%string%",
"INBOX_NO_REPORTS": "* No Reports *",
"INBOX_NO_REPORT_TITLE": "(No Title)",
"INBOX_INBOX_LOADED": "Inbox loaded.",
"INBOX_CONFIRM_DELETE_ALL": "Delete all reports?",
"INBOX_CONFIRM_DELETE": "%string%\nDelete this report?",
"INBOX_CONFIRM_EXIT": "Reports cannot be sent to you while %string% is not running.\n\nExit the program?",
"INBOX_DELETED": "Successfully deleted %string%",
"INBOX_DELETED_ALL": "Successfully deleted all items",
"INBOX_NO_FAVOURITES": "* No Favorites *",
"INBOX_FINISHED_REFRESHING_REPORTS": "Finished refreshing recently-run reports.",
"INBOX_SUCCESSFULLY_REFRESHED_REPORTS": "Successfully refreshed recently-run reports.",
"INBOX_PROBLEM_REFRESHING_REPORTS": "Errors were encountered while refreshing recently-run reports.",
"INBOX_RESTORED_INBOX": "Successfully loaded inbox.",
"INBOX_FAILED_TO_RESTORE_INBOX": "Errors were encountered while loading the inbox.",
"INBOX_MARK_AS_FAVOURITE": "%string% has been successfully set as a favorite.",
"INBOX_REMOVE_AS_FAVOURITE": "%string% is no longer a favorite.",
"INBOX_MARK_AS_WELCOME": "%string% has been successfully added to the Welcome page.",
"INBOX_REMOVE_AS_WELCOME": "%string% has been removed from the Welcome page.",
"RINFO_IN_LESS_THAN_MINUTE": "in less than a minute",
"RINFO_LESS_THAN_MINUTE_AGO": "less than a minute ago",
"RINFO_IN_X_MINUTES": "in %integer% minutes",
"RINFO_X_MINUTES_AGO": "%integer% minutes ago",
"RINFO_IN_ONE_HOUR": "in 1 hour",
"RINFO_ONE_HOUR_AGO": "1 hour ago",
"RINFO_IN_X_HOURS": "in %integer% hours",
"RINFO_X_HOURS_AGO": "%integer% hours ago",
"RINFO_TOMORROW_AT": "Tomorrow at %string%",
"RINFO_YESTERDAY_AT": "Yesterday at %string%",
"RINFO_IN_X_DAYS": "in %integer% days",
"RINFO_X_DAYS_AGO": "%integer% days ago",
"BROWSE_TITLE": "Browse",
"BROWSE_NO_SERVER": "* no server specified *",
"BROWSE_COGNOS_CONNECTION": "Cognos Connection",
"BROWSE_LOADING": "Loading...",
"BROWSE_NOT_AVAILABLE": "* not available *",
"BROWSE_MENU_ERROR_DETAILS": "Error Details",
"BROWSE_MENU_OPTIONS": "Options",
"BROWSE_MENU_RUN_REPORT": "Run Report",
"BROWSE_CONFIRM_RUN_REPORT": "Run this report?\n%string%",
"PAGE_REPORT_TIMESTAMP": "%longDate% %shortTime%",
"PAGE_TOOLTIP_AT_PAGE_N_OF_N": "%string%\nPage %integer% of %integer%",
"PAGE_TOOLTIP_ZOOM_N_PERCENT": "Zoom %integer%%",
"PAGE_CHOICE": "Select the page.",
"PAGE_SELECT": "Select",
"OBJECT_TOOLTIP_OBJECT_FOCUS": "Focus",
"OBJECT_TOOLTIP_TABLE_FOCUS": "Table Focus",
"OBJECT_TOOLTIP_TEXT_FOCUS": "Text Focus",
"OBJECT_TOOLTIP_IMAGE_FOCUS": "Image Focus",
"OBJECT_TOOLTIP_CHART_FOCUS": "Chart Focus",
"OBJECT_TOOLTIP_FOOTER_FOCUS": "Footer Focus",
"OBJECT_TOOLTIP_HEADER_FOCUS": "Header Focus",
"OBJECT_TOOLTIP_MARKED_CELL": "Cell marked for focus",
"OBJECT_TOOLTIP_UNMARKED_CELL": "Cell unmarked",
"FOCUS_TOOLTIP_ROW_FOCUS": "Row Focus (Row %integer% of %integer%)",
"FOCUS_TOOLTIP_COLUMN_FOCUS": "Column Focus (Column %integer% of %integer%)",
"OPTIONS_TITLE": "Options",
"OPTIONS_SERVER": "Server:",
"OPTIONS_SERVER_MRU": "Recently Used URLs",
"OPTIONS_PAGE_INITIAL_ZOOM": "Page Initial Zoom:",
"OPTIONS_TEXT_INITIAL_ZOOM": "Text Initial Zoom:",
"OPTIONS_IMAGE_INITIAL_ZOOM": "Image Initial Zoom:",
"OPTIONS_FIT_TO_WIDTH": "Fit to Width",
"OPTIONS_FIT_TO_PAGE": "Fit to Page",
"OPTIONS_ZOOM_N_PERCENT": "%integer%%",
"OPTIONS_FONT_SIZE": "Font Size:",
"OPTIONS_INBOX_SORT_ORDER": "Inbox Sort Order:",
"OPTIONS_INBOX_SORT_ORDER_NAME": "By Name",
"OPTIONS_INBOX_SORT_ORDER_DATE": "By Date",
"OPTIONS_MENU_ADVANCED": "Advanced",
"OPTIONS_FONT_SMALL": "SMALL",
"OPTIONS_FONT_MEDIUM": "MEDIUM",
"OPTIONS_FONT_LARGE": "LARGE",
"OPTIONS_LOCATION": "Use Location?",
"OPTIONS_GPS_ALWAY_ON": "GPS always on?",
"OPTIONS_GPS_WARNING": "(GPS usage increases battery drain.)",
"LOCATION_NO": "No",
"LOCATION_YES": "Yes",
"LOCATION_DISABLED": "Available but disabled",
"LOCATION_STATUS": "Status: %string%",
"LOCATION_UNAVAILABLE": "Unavailable",
"LOCATION_UNSUPPORTED": "Not supported or not configured on this device",
"LOCATION_AVAILABLE": "Available",
"LOCATION_OUT_OF_SERVICE": "Out of service",
"LOCATION_TEMPORARILY_UNAVAILABLE": "Temporarily unavailable",
"LOCATION_UNKNOWN_STATUS": "Unknown",
"LOCATION_OK": "OK (accuracy %string% m; '%string%')",
"LOCATION_STOPPED": "Stopped",
"LOCATION_READING": "Obtaining current location...",
"LOCATION_ALWAYS": "Always",
"LOCATION_ASK": "Ask",
"LOCATION_NEVER": "Never",
"LOCATION_USE_1": "The report requires a location. Use your current location?",
"LOCATION_USE_2": "Use your current location?",
"LOCATION_FAILED": "Unable to obtain current location",
"LOCATION_GPS_ALWAYS_ON": "GPS usage increases battery drain. Do you want to keep the GPS warmed-up for this session?",
"LOCATION_CANNOT_START": "Cannot start location service.",
"LOCATION_CANNOT_READ": "Cannot obtain current location.",
"LOCATION_CANNOT_PARSE_CONFIG": "Cannot parse location configuration file.",
"ABOUT_TITLE": "About %string%",
"ABOUT_VERSION": "Version: %integer%.%integer% build %integer%",
"ABOUT_VERSION_NFR": "Version: %integer%.%integer% build %integer% - Not For Resale",
"ABOUT_GETTING_SERVER_INFO": "(Getting server information...)",
"ABOUT_NO_SERVER": "Server not currently available",
"ABOUT_SERVER_VERSION": "Server Version: %integer%.%integer% build %integer% [%string%]",
"ERRORDIALOG_TITLE": "Error - %string%",
"ERRORDIALOG_OK": "OK",
"ERRORDIALOG_DETAILS": "Details",
"ERROR_WARNING": "An error has occurred!",
"ERROR_DETAILS": "Error Details:",
"ERROR_HINTS": "( Error details on next page. )",
"SYNC_CONNECTING": "Connecting...",
"SYNC_CONNECTING_CANCELED": "Connection canceled",
"SYNC_CONNECTING_FAILED": "Connection failed",
"SYNC_CONNECTED": "Connected",
"SYNC_STARTING": "Sync starting...",
"SYNC_STARTED": "Sync started",
"SYNC_UPLOADING": "Uploading...",
"SYNC_UPLOADING_X_PERCENT_COMPLETE": "Uploading (%integer%%)...",
"SYNC_UPLOADED": "Uploaded",
"SYNC_DOWNLOADING": "Downloading...",
"SYNC_DOWNLOADING_X_PERCENT_COMPLETE": "Downloading (%integer%%)...",
"SYNC_DOWNLOADED": "Downloaded",
"SYNC_SYNCHRONIZING_CANCELED": "Synchronization canceled",
"SYNC_SYNCHRONIZING_FAILED": "Synchronization failed",
"SYNC_SYNCHRONIZED": "Synchronized",
"SYNC_STARTED_BY_USER": "Sync started by user",
"SYNC_STOPPED_BY_USER": "Sync stopped by user",
"SYNC_REBUILDING_INBOX": "Rebuilding inbox...",
"SYNC_STARTED_EXPLANATION": "Reports will now be synchronized to your inbox.",
"FINDDIALOG_TITLE": "Find in Page",
"FINDDIALOG_FIND": "Find",
"FINDDIALOG_CANCEL": "Cancel",
"FINDDIALOG_NOMATCH": "No matches found",
"FINDDIALOG_FINDWHAT": "Find what:",
"CRPDIALOG_YES": "Yes",
"CRPDIALOG_NO": "No",
"SEARCH_TITLE": "Search",
"SEARCH_SEARCH": "Search",
"SEARCH_EDIT_TERM": "Enter",
"SEARCH_TERM": "Term:",
"SEARCH_NEW": "New",
"SEARCH_SEARCHING": "Searching",
"SEARCH_ENTER_A_SEARCH_TERM": "Enter a term to search for, and click 'Search'.",
"SEARCH_ENTER_A_SEARCH_TERM2": "Search for:",
"SEARCH_NOREPORTSFOUND": "* No Reports Found *",
"SEARCH_MENU_RUN_REPORT": "Run Report",
"SEARCH_SOURCE_PATH": "...%string%",
"ZOOMGOTO_FIT_TO_WIDTH": "Fit to Width",
"ZOOMGOTO_FIT_TO_PAGE": "Fit to Page",
"ZOOMGOTO_ZOOM_N_PERCENT": "%integer%%",
"ZOOMGOTO_CHOICE_ZOOM": "Select the zoom level.",
"ZOOMGOTO_SELECT_ZOOM": "Zoom",
"DETAILS_TITLE": "Details",
"DETAILS_REPORT_PATH": "Report Path: %string%",
"DETAILS_REPORT_URL": "Report URL: %string%",
"DETAILS_PARAMETERS": "Drill Parameters: %string%",
"DETAILS_RUN_TIME": "Run Time: %longDate%",
"DETAILS_SIZE": "Size: %integer%",
"DETAILS_SIZE_BYTES": "%integer% bytes",
"DETAILS_SIZE_KB": "%integer% KB",
"DETAILS_SIZE_MB": "%integer% MB",
"DETAILS_SIZE_GB": "%integer% GB",
"DETAILS_SIZE_DECIMAL": ".",
"DETAILS_MENU_RUN_REPORT": "Re-run Report",
"DETAILS_MENU_COPY_REPORT_URL": "Copy Report URL",
"DETAILS_RENDER_SOURCE": "Render Source: %string%",
"DETAILS_RENDER_SOURCE_ADHOC": "Ad hoc",
"DETAILS_RENDER_SOURCE_SCHEDULED": "Scheduled",
"DETAILS_RENDER_SOURCE_DRILLTHROUGH": "Drill-through",
"DETAILS_RENDER_SOURCE_PROMPTED": "Prompted",
"PROMPTS_SELECT_FROM_FOLLOWING": "Select from the following",
"PROMPTS_EDIT_SELECTED": "Modify selected",
"PROMPTS_FIX": "Fix",
"PROMPTS_SELECTED": "Selected",
"PROMPTS_CONTAINING": "Containing",
"PROMPTS_ADD_ALL": "Add all",
"PROMPTS_REMOVE_ALL": "Remove all",
"PROMPTS_REMOVE_SELECTED": "Remove selected",
"PROMPTS_BACK": "Ok",
"PROMPTS_BACKBACK": "Back",
"PROMPTS_NEXT": "Next",
"PROMPTS_EDIT": "Edit",
"PROMPTS_SUBMIT": "Submit",
"PROMPTS_SEARCHSELECT": "Search:",
"PROMPTS_CHOICES": "Choices:",
"PROMPTS_FINISHED": "Finished",
"PROMPTS_RESET": "Reset",
"PROMPTS_SET_TO_EARLIEST": "Set to earliest",
"PROMPTS_SET_TO_LATEST": "Set to latest",
"PROMPTS_SET_TO_LOWEST": "Set to lowest",
"PROMPTS_SET_TO_HIGHEST": "Set to highest",
"PROMPTS_DATASOURCE": "Data source",
"PROMPTS_CONNECTION": "Connection",
"PROMPTS_USERID": "User ID",
"PROMPTS_PASSWORD": "Password",
"PROMPTS_SELECTSIGNONTITLE": "Select a signon to use for this connection",
"PROMPTS_SELECTSIGNON": "Select a signon",
"PROMPTS_DAYS": "days",
"PROMPTS_HOURS": "hr",
"PROMPTS_MINUTES": "min",
"PROMPTS_SECONDS": "s",
"PROMPTS_MILLISECONDS": "ms",
"PROMPTS_START": "From",
"PROMPTS_END": "To",
"PROMPTS_INSERT": "Insert",
"PROMPTS_REMOVE": "Remove",
"PROMPTS_SELECT": "Select",
"PROMPTS_DESELECT": "Deselect",
"PROMPTS_SELECT_ALL": "Select all",
"PROMPTS_DESELECT_ALL": "Deselect all",
"SERVER_WELCOME_AND_ENTER_URL": "Welcome to %string%!\nTo begin, please enter the URL to your %string% server:",
"SERVER_WELCOME": "Welcome to %string%!",
"SERVER_WELCOME_ENTER_URL": "To begin, please enter the URL to your %string% server:",
"SERVER_ENTER_URL": "Please check the URL of your %string% server.",
"SERVER_URL": "URL:",
"SERVER_CONNECT": "Connect",
"SERVER_DETAILS": "Details",
"GEEKOPTIONS_TITLE": "Advanced Options",
"GEEKOPTIONS_LOG_LEVEL": "Log Level:",
"GEEKOPTIONS_LOG_LEVEL_DEBUG": "Debug",
"GEEKOPTIONS_LOG_LEVEL_INFORMATION": "Information",
"GEEKOPTIONS_LOG_LEVEL_WARNING": "Warning",
"GEEKOPTIONS_LOG_LEVEL_ERROR": "Error",
"GEEKOPTIONS_LANGUAGE": "Language:",
"GEEKOPTIONS_LANGUAGE_AUTODETECT": "Autodetect",
"GEEKOPTIONS_LANGUAGE_EN": "English",
"GEEKOPTIONS_LANGUAGE_FR": "French",
"GEEKOPTIONS_LANGUAGE_DE": "German",
"GEEKOPTIONS_LANGUAGE_JA": "Japanese",
"GEEKOPTIONS_LANGUAGE_ES": "Spanish",
"GEEKOPTIONS_LANGUAGE_FI": "Finnish",
"GEEKOPTIONS_LANGUAGE_IT": "Italian",
"GEEKOPTIONS_LANGUAGE_NL": "Dutch",
"GEEKOPTIONS_LANGUAGE_PT": "Portuguese",
"GEEKOPTIONS_LANGUAGE_RU": "Russian",
"GEEKOPTIONS_LANGUAGE_SV": "Swedish",
"GEEKOPTIONS_LANGUAGE_ZH_CN": "Chinese (China)",
"GEEKOPTIONS_LANGUAGE_TR": "Turkish",
"GEEKOPTIONS_LANGUAGE_RO": "Romanian",
"GEEKOPTIONS_LANGUAGE_CS": "Czech",
"GEEKOPTIONS_LANGUAGE_HU": "Hungarian",
"GEEKOPTIONS_LANGUAGE_PL": "Polish",
"GEEKOPTIONS_SYNCHRONIZATION": "Synchronization",
"GEEKOPTIONS_PREFERRED_SYNC_METHOD": "Preferred synchronization method:",
"GEEKOPTIONS_SYNC_METHOD_NONE": "Manual",
"GEEKOPTIONS_SYNC_METHOD_S2": "Auto",
"GEEKOPTIONS_SERVER_STATUS": "Server Status:",
"GEEKOPTIONS_SERVER_STATUS_ENABLED": "Enabled",
"GEEKOPTIONS_SERVER_STATUS_ENABLED_STOPPED": "Enabled (but stopped by user)",
"GEEKOPTIONS_SERVER_STATUS_DISABLED": "Disabled",
"GEEKOPTIONS_SYNC_ID": "Sync ID:",
"GEEKOPTIONS_SYNC_ID_NOT_LOGGED_ON": "Not Logged On",
"GEEKOPTIONS_HTTP_LOG_ADDRESS": "HTTP Log Address:",
"GEEKOPTIONS_RESTART_IS_REQUIRED": "Please select Exit and restart %string% to apply these new options.",
"GEEKOPTIONS_WARNING": "Warning",
"DTH_OPEN_EXISTING_REPORT": "Open the existing report in your inbox?",
"DTH_OPEN_EXISTING_REPORT_2": "Open the version of the report already stored on this device?",
"HELP_TITLE": "Help",
"HELP_NAVIGATE_INTRO": "You can use the number keys as navigation shortcuts:",
"HELP_NAVIGATE_1": "1 - Home",
"HELP_NAVIGATE_9": "9 - End",
"HELP_NAVIGATE_2": "2 - Up",
"HELP_NAVIGATE_8": "8 - Down",
"HELP_NAVIGATE_4": "4 - Left",
"HELP_NAVIGATE_6": "6 - Right",
"HELP_OTHER_INTRO": "Other shortcuts:",
"HELP_OTHER_ENTER": "Enter - Open",
"HELP_OTHER_Q": "Q - Zoom In",
"HELP_OTHER_A": "A - Zoom Out",
"HELP_OTHER_Z": "Z - Zoom...",
"HELP_OTHER_P": "P - Page...",
"HELP_OTHER_5": "5 - Mark Cell",
"ERROR_GENERIC": "An unexpected error occurred.",
"ERROR_FAILED_TO_BUILD_SCENE": "An error occurred while displaying the report.\n%string%",
"ERROR_FAILED_TO_PAINT_SCENE": "An error occurred while displaying the report \n%string%",
"ERROR_CONNECT_TO_MOBILE_SERVER_FAILED": "Unable to connect to the server. Please check your server options and ensure that you have wireless connectivity.",
"ERROR_INVALID_RESPONSE_RETURNED": "The server returned an invalid response. Please check that your server options are correct.",
"ERROR_FAILED_TO_RUN_REPORT": "Unable to run the report.",
"ERROR_CONNECT_FAILED": "Unable to establish a connection to the server.",
"ERROR_INVALID_IMAGE_TYPE": "Encountered an invalid image type. The image will not be displayed.",
"ERROR_IMAGE_DOWNLOAD_FAILED": "Unable to download an image.",
"ERROR_SERVER_RESPONSE_PARSE_FAILED": "Unable to understand the response from the server.",
"ERROR_SERVER_NOT_AVAILABLE_IN_DEMO": "This feature is not available in the demonstration but is a standard feature of %string%.",
"ERROR_DEVICE_IS_OFFLINE": "The wireless radio is currently offline.",
"ERROR_FULL_SYNC_FAILED": "Unable to complete the inbox synchronization. Please try again later.",
"ERROR_DATABASE_OPEN_FAILED": "Unable to open the inbox.",
"ERROR_DATABASE_READ_FAILED": "Unable to read the inbox.",
"ERROR_SYNC_FAILED": "Encountered a problem synchronizing the inbox contents.",
"ERROR_RENDER_READ_FAILED": "Unable to read the report.",
"ERROR_SETTINGS_FILE_MISSING": "Unable to find the settings file. Please reinstall the program.",
"ERROR_LEASE_EXPIRED": "The encryption key has expired. Please log on again to access your reports.",
"ERROR_DRILLTHROUGH_FAILURE": "Encountered a problem while performing a drill-through operation.",
"ERROR_SERVER_VERION_IS_OLDER": "Unable to log on. The server version is too old.",
"ERROR_REGISTRY": "Unable to access the Windows registry.",
"ERROR_SERIALIZATION": "An error occurred while accessing local settings.",
"ERROR_NO_PORTAL_ROOTS": "No portal folders are available to browse.",
"ERROR_OPERATION_CANCELLED": "Operation cancelled.",
"ERROR_READING_CACHE": "Error reading stored report %string%: %string%",
"DEMO_EXCEPTION_DETAILS": "Please visit http://www.cognos.com/mobilestarterkit/ to learn more about how you can get up and running with %string%.",
"MENU_EXIT_DEMO_INBOX": "Exit Demo Inbox",
"CALLDIALOG_TITLE": "Edit Phone Number",
"CALLDIALOG_CALL": "Call",
"CALLDIALOG_CANCEL": "Cancel",
"CALLDIALOG_PHONE_NUMBER": "Phone Number:",
"CONFIGTEST_LABEL": "Mobile database connection",
"CONFIGTEST_DESC": "Testing Connection For Mobile database",
"CONFIGTEST_ERROR_2100": "Failed to read Mobile Parameters",
"CONFIGTEST_ERROR_2101": "No Logging Database Output defined",
"CONFIGTEST_ERROR_2102": "Logging is missing Driver for Database:",
"CONFIGTEST_ERROR_2103": "Logging is missing Connection String for Database:",
"CONFIGTEST_ERROR_2104": "Logging is missing Database Server and Port",
"CONFIGTEST_ERROR_2105": "Logging is missing Database ",
"CONFIGTEST_ERROR_2106": "Logging failed to connect to Database:",
"WEB_VIEWERFOCUSON": "Focus on '%string%'",
"WEB_VIEWERHIDE": "Hide '%string%'",
"WEB_VIEWERUNHIDE": "Unhide '%string%'",
"WEB_ADDTOWELCOME": "welcome",
"WEB_ADDTOFAVOURITES": "favorite",
"WEB_APPNAME": "IBM Cognos Mobile",
"WEB_MYMOBILE_TITLE": "My Mobile",
"WEB_BROWSE_TITLE": "Browse",
"WEB_SEARCH_TITLE": "Search",
"WEB_RECENTLYRUN": "Recently run reports",
"WEB_DASHBOARD": "Welcome '%string%'",
"WEB_EDIT": "Edit",
"WEB_CLOSE": "Close",
"WEB_CANCEL": "Cancel",
"WEB_REMOVE": "Remove",
"WEB_ABOUT": "About",
"WEB_ABOUT_VERSION": "Version:",
"WEB_ABOUT_BUILD": "build",
"WEB_OK": "OK",
"WEB_LOGON": "Log On",
"WEB_LOGOFF": "Log Off",
"WEB_NOREPORTS1": "You haven't recently run any reports.  Please select ",
"WEB_NOREPORTS2": " or ",
"WEB_NOREPORTS3": " to run one now.",
"WEB_REPORTSOURCE_SCHEDULED": "Scheduled, ",
"WEB_REPORTSOURCE_PROMPTED": "Prompted, ",
"WEB_REFRESHREPORT": "refresh",
"WEB_OPENINGREPORT": "Opening %string%",
"WEB_RUNNINGREPORT": "Running %string%",
"WEB_RUNBACKGROUND": "Run in background",
"WEB_REPORTITLE_LASTRUN": "%string%<div id='titlebar_lastrun'>last run %string%</div>",
"WEB_FAVOURITES": "Favorites",
"WEB_PROMPT_LESSTHANOREQUAL": "less than or equal to %string%",
"WEB_PROMPT_GREATERTHANOREQUAL": "greater than or equal to %string%",
"WEB_PROMPT_ONORAFTER": "on or after %string%",
"WEB_PROMPT_ONORBEFORE": "on or before %string%",
"WEB_PROMPT_BETWEEN": "between %string% and %string%",
"WEB_PROMPT_START": "Start",
"WEB_PROMPT_END": "End",
"WEB_PROMPT_FROM": "From",
"WEB_PROMPT_TO": "To",
"WEB_PROMPT_INSERT": "insert",
"WEB_PROMPT_REMOVE": "remove",
"WEB_PROMPT_SELECT_ALL": "Select all",
"WEB_PROMPT_DESELECT_ALL": "Deselect all",
"WEB_PROMPT_SEARCH": "Search",
"WEB_PROMPT_CHOICE": "Choice",
"WEB_PROMPT_KEYWORDS": "Keywords",
"WEB_PROMPT_USERNAME": "User ID",
"WEB_PROMPT_PASSWORD": "Password",
"WEB_PROMPT_DATASOURCE": "Data source",
"WEB_PROMPT_CONNECTION": "Connection",
"WEB_PROMPT_SELECTSIGNONMSG": "Select a signon to use for this connection.",
"WEB_PROMPT_SELECTSIGNON": "Select a signon",
"WEB_PROMPT_CONNECTFAILED": "An attempt to connect to the data source failed.",
"WEB_PROMPT_BUTTONS_CANCEL": "Cancel",
"WEB_PROMPT_BUTTONS_BACK": "Back",
"WEB_PROMPT_BUTTONS_FORWARD": "Forward",
"WEB_PROMPT_BUTTONS_FINISH": "Finish",
"WEB_PROMPT_BUTTONS_REPROMPT": "Reprompt",
"WEB_PROMPT_INTERVAL_DAYS": "days",
"WEB_PROMPT_INTERVAL_HOURS": "hours",
"WEB_PROMPT_INTERVAL_MINUTES": "mins",
"WEB_PROMPT_INTERVAL_SECONDS": "s",
"WEB_PROMPT_INTERVAL_MILLISECONDS": "ms",
"WEB_CHECKING_FOR_PROMPTS": "Checking for prompts...",
"WEB_VERSION": "Version",
"WEB_NOITEMSFOUND": "No items found.",
"WEB_SORRYTHEFOLLOWINGERROR": "Sorry!  The following error occurred when making your request",
"WEB_LOADINGMOBILE": "loading IBM Cognos Mobile...",
"WEB_LOADING": "Loading...",
"WEB_DRILLUP": "Drill Up",
"WEB_DRILLDOWN": "Drill Down",
"WEB_DRILLTHROUGH": "DrillThrough",
"WEB_PAGE": "page",
"WEB_MORE": "more...",
"WEB_ABOUT_NO_SERVER": "Server not currently available",
"WEB_NO_FAVOURITES": "You have no favorite reports.  To mark a report as a favorite, open it and check the 'favorite' box.",
"WEB_NO_WELCOME": "Did you know you can insert your most commonly viewed report on this page?  Just open a report and check the 'welcome' box.",
"WEB_VALIDATE_ERROR": "Error:",
"WEB_VALIDATE_WARNING": "Warning:",
"WEB_VALIDATE_REQUIRED": "This field is required.",
"WEB_VALIDATE_NUMERIC": "Please enter only numeric values in this field.",
"WEB_VALIDATE_AFTER_ONLY": "Please enter a value after '%string%'.",
"WEB_VALIDATE_BEFORE_ONLY": "Please enter a value before '%string%'.",
"WEB_VALIDATE_EARLIEST_ACCEPTABLE": "The earliest acceptable value is '%string%'.",
"WEB_VALIDATE_LATEST_ACCEPTABLE": "The latest acceptable value is '%string%'.",
"WEB_GREGORIAN_DAYS_SHORT": "S|M|T|W|Th|F|S",
"WEB_GREGORIAN_DAYS_MED": "Sun|Mon|Tues|Wed|Thurs|Fri|Sat",
"WEB_GREGORIAN_DAYS": "Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday",
"WEB_GREGORIAN_MONTHS_SHORT": "Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sept|Oct|Nov|Dec",
"WEB_GREGORIAN_MONTHS": "January|February|March|April|May|June|July|August|September|October|November|December",
"WEB_YEAR": "Year",
"WEB_MONTH": "Month",
"WEB_DAY": "Day",
"WEB_HOUR": "Hour",
"WEB_MINUTE": "Minute",
"WEB_SECOND": "Second",
"WEB_MSECOND": "Millisecond",
"WEB_YEAR_SHORT": "yr",
"WEB_MONTH_SHORT": "m",
"WEB_DAY_SHORT": "d",
"WEB_HOUR_SHORT": "h",
"WEB_MINUTE_SHORT": "m",
"WEB_SECOND_SHORT": "s",
"WEB_MSECOND_SHORT": "ms",
"WEB_DATE_LESSTHANMINUTEAGO": "less than a minute ago",
"WEB_DATE_MINUTEAGO": "about a minute ago",
"WEB_DATE_MINUTESAGO": "{delta} minutes ago",
"WEB_DATE_HOURAGO": "about an hour ago",
"WEB_DATE_HOURSAGO": "about {delta} hours ago",
"WEB_DATE_DAYAGO": "1 day ago",
"WEB_DATE_DAYSAGO": "{delta} days ago",
"WEB_DATE_LESSTHANMINUTEUNTIL": "less than a minute from now",
"WEB_DATE_MINUTEUNTIL": "about a minute from now",
"WEB_DATE_MINUTESUNTIL": "{delta} minutes from now",
"WEB_DATE_HOURUNTIL": "about an hour from now",
"WEB_DATE_HOURSUNTIL": "about {delta} hours from now",
"WEB_DATE_DAYUNTIL": "1 day from now",
"WEB_DATE_DAYSUNTIL": "{delta} days from now",
"WEB_PROMPT_AM": "AM",
"WEB_PROMPT_PM": "PM",
"WEB_CONNECTING": "Connecting...",
"WEB_CONNECT": "Connect...",
"WEB_ENTER_KEYWORDS": "Enter keywords...",
"WEB_REFRESHING": "Refreshing screen...",
"WEB_PLEASESELECTDRILLTARGETS": "Please select drill target: ",
"EUI_NO_RENDERS": "You haven't recently run any reports.  Please select the Browse or Search tabs below to find a report to run now.",
"EUI_NO_WELCOME": "Did you know you can insert your most commonly viewed report on this page?  Open a report and select the 'Add to Welcome page' menu option.",
"EUI_NO_FAVOURITES": "You have no favorite reports.  To mark a report as a favorite, open the report, then select the 'Set as Favorite' menu option."};

function $i18n(key, args){
	var result = i18n[key];
	if( result == null ) return key;
	if( !$defined(args)) return result;

	var reg = /%[\S]+?%/g;
	var m = result.match(reg);
	var s = "";
	var start = 0;
	var end = 0;
	for( var i = 0; i < m.length; i++ ){
		start = result.indexOf(m[i], end);
		s += result.substring(end, start) + args[i];
		end = start + m[i].length;
	}
	s += result.substring(end);
	return s;
};
	